{$DEFINE JPIRCWIN}

Unit FINGERD;        {    FINGER Server for use with JP's Trumpet ABI unit  }

Interface

Uses ABI, ABI_DOM, ABI_JP, JP_UNIT,
{$IFDEF JPIRCWIN}
     JPIRCWIN,
{$ENDIF}
     INI_MGR;

CONST  INIFileName = 'JPTCP.INI';

var FDState:Byte;
    Queries:Word;
      FDS    : ^tcpSessionREC;
      FDUserName : ^String;
      FD_OS      : ^String;
      FDStatus   : ^String;
      FDPort     : Word;

Procedure ProcessTcpFD;

Implementation

var   SaveExitProc : Pointer;
      Result       : Word;
      FDBuffer  : ^BufferREC;
      A, B, C      : ^String;
      FingerLog     : text;

Procedure ProcessTcpFD;
var tResult:Integer;
    tSPort, tCPort : Word;
Begin

tResult:=tcp_Status(FDS^, 0);

Str(FDState,FDStatus^);
FDStatus^:='['+FDStatus^+'] ';

Case FDState of
 0 :  Begin   {Check for Connection}
       If FDS^.Status.State=4 then
           begin
             result:=tcp_status(FDS^, 0);
             Writeln(FingerLog, 'Connected Rcvd: '+IPTOASCII(FDS^.Status.ip_dest)+
                               ':',FDS^.Status.port_dest);

{$IFDEF JPIRCWIN}
             Str(FDS^.Status.port_dest, A^);
             WlnWrite(1, 'FINGER Req Rcvd From '+IPTOASCII(FDS^.Status.ip_dest)+
                               ':'+A^);
{$ENDIF}
             FDState:=2;
             Queries:=0;
           end;
      End;
 1 :  Begin
       asm nop end;
       FDState:=5;
      End;
 2 :  Begin   {Recieve Line of Data}
        DoShowTcpError:=False;
        If not tcp_IsConnected(FDS^) then
            begin
              Writeln(FingerLog, 'Was disconnected while waiting for Line of Data');
              FDState:=5;
              exit;
            end;
        If ReadlnBuff(FDS^, FDBuffer^) then FDState:=3;
        DoShowTcpError:=True;
      End;
 3 :  Begin   {Process Line of Data}
         InvalidChar:=#0+#13+#10+#32;
         B^ := ShowBuffer(FDBuffer^, 4);
         Writeln(FingerLog, 'Rcvd: "'+B^+'"');
         FDStatus^:=FDStatus^+'Received: '+B^;
         C^ := 'Uknown User';
         If (uCase(B^) = 'ROOT') or (uCase(B^) = 'SYSOP') then
           begin
             C^ := 'This is the default Root finger reply';
           end;
         AddBuffer(FDS^.Buffer, 0, C^);
         FDBuffer^.Length:=0;
         FDState:=4;
      End;
 4 :  Begin   { Send Reply Non-Blockingly }
        Inc(Queries);
        If not tcp_IsConnected(FDS^) then
            begin
              FDState:=5;
              B^ := ShowBuffer(FDS^.Buffer, 4);
                  Writeln(FingerLog, 'Sent?: "'+B^+'"');
              exit;
            end;

        { tcp_Put(FDS^, 2+4, 375); }

        Result:=tcp_Put(FDS^, 6, 375);
        B^:=ShowBuffer(FDS^.Buffer, 0);
        If Result=0 then
          begin
           Writeln(FingerLog, 'Send: "'+B^+'"');
{$IFDEF JPIRCWIN}
           WlnWrite(1, 'FINGER Reply Sent: '+B^);
{$ENDIF}
          end;
        FDState:=2;
        DelayMS(25);
        If Queries>4 then FDState:=5;
      End;
 5 :  Begin   { Reclose connection }
          DelayMS(100);
          Result:=tcp_Close(FDS^, 1, 0);
          DelayMS(25);
          Result:=Tcp_Open(FDS^, 1, NullAddr, FDPort, 0, 0);
          If Result<>0 then
              begin
                Writeln('ERROR with close->ReOpenning Listening connection on port ',FDPort);
              end;
        Writeln(FingerLog, 'Closed for reopen.');
          FDState:=0;
      End;
  Else
     FDState:=0;
 End;

asm nop end;
If (Tcp_State(FDS^)=7) and (FDS^.Buffer.Length=0) then FDState:=5;
If (Tcp_State(FDS^)=1) and (FDS^.Buffer.Length=0) then FDState:=0;

End;


Procedure InitFD;
Begin
 FillChar(FDS^, SizeOf(FDS^), #0);
 FDState:=0;
 FDPort := FINGER_PORT;
 FDUserName^:='USERID';
 FD_OS^     :='MSDOS,US-ASCII';
 FDBuffer^.Length:=0;
End;


{$F+}
Procedure FD_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   Close(FingerLog);
   Result:=tcp_Close(FDS^, 0, 350);
   If Result<>0 then Writeln('Error with FD closing FDS! ',Result);

   Dispose(FD_OS);  Dispose(FDUserName);
   Dispose(C);  Dispose(B);  Dispose(A);
   Dispose(FDBuffer);
   Dispose(FDS);
   Dispose(FDStatus);
 end;

var  FAP          : FieldType;

BEGIN
 New(FDStatus);
 New(FDS);
 New(FDBuffer);
 New(A);   New(B);  New(C);
 New(FDUserName);
 New(FD_OS);

 InitFD;

 FAP.Field:='UserName';   FAP.Value:='';
 LoadINISection(INIFileName, 'fingerd', 1, @FAP);
 If FAP.Value<>'' then FDUserName^ := FAP.Value;

 FAP.Field:='OS';   FAP.Value:='';
 LoadINISection(INIFileName, 'fingerd', 1, @FAP);
 If FAP.Value<>'' then FD_OS^ := FAP.Value;

 FAP.Field:='Port';   FAP.Value:='';
 LoadINISection(INIFileName, 'fingerd', 1, @FAP);
 If FAP.Value<>'' then
   begin
     Val(FAP.Value, FDPort, Result);
     If (Result<>0) or (FDPort=0) then FDPort := FINGER_PORT;
   end;

 Result:=Tcp_Open(FDS^, 1, NullAddr, FDPort, 0, 0);
 If Result<>0 then
     begin
       Writeln('Error initializing NTCPDRV to listen on port ',FDPort);
       DelayMS(500);
       Halt(113);
     end;
 SaveExitProc:=ExitProc;
 ExitProc:=@FD_NewExitProc;
 Assign(FingerLog, 'FD.LOG');
 ReWrite(FingerLog);
END.    (C) 1997 - Copyright ParSoft, by Jeff Patterson

