{$IFDEF OVERLAY}
{$O+}
{$ENDIF}
Unit Encrypt;      {For jpIRC}

Interface

Uses JP_UNIT,JPIRCWIN;

TYPE  KeyEntryPTR = ^KeyEntryREC;
      KeyEntryREC = RECORD
                   next : KeyEntryPTR;
                   method : Byte;      { 0 = SED }
                                       {13 = ROT13}
                                       { 1 = External (my that would be slow)}
                                       { 2 = simple XOR }
                   who : String[200];
                   key : String[127];
                 END;

var  FirstKey: KeyEntryPTR;


Procedure DoListEncrypt(Opt:Byte);
Function DoInsEncrypt(who:String;  method:Byte;  key:String):Boolean;  {True=OK}
Function DoDelEncrypt(who : String): Boolean;                          {True=OK}

Function SED_Encrypt( nickchan, StrIn:String; var StrOut:String):Boolean;
{TRUE = OK}

Function SED_Decrypt( nickchan, StrIn:String; var StrOut:String):Boolean;
{TRUE = OK}


Implementation

var  CurrentKey: KeyEntryPTR;
     NewKey: KeyEntryPTR;

{True on Error}
Function zRetreive(var TheFirst:Boolean):Boolean;
Begin
  zRetreive := False;
  If TheFirst then
    begin
     CurrentKey := FirstKey;
     If FirstKey = nil then zRetreive := True;
     TheFirst := False;
     exit;
    end;
  If (CurrentKey = nil) or (CurrentKey^.next = nil) then
    begin
      zRetreive := True;
      exit;
    end;
  CurrentKey := CurrentKey^.next;
End;

Function RetreiveKey(who:String):KeyEntryPTR;
var TmpB : Boolean;
Begin
 RetreiveKey := nil;
 If who='' then
   begin
    exit;
   end;
 TmpB:=True;

 while not zRetreive(TmpB) do
   begin
     If uCase(who)=uCase(CurrentKey^.who) then
       begin
         RetreiveKey := CurrentKey;
         break
       end;
   end;
End;

Procedure DoListEncrypt(Opt:Byte);
var TmpB:Boolean;
    TmpStr:String;
Begin
 TmpB:=True;
 Str(CurrentKey^.method:3, TmpStr);
 WlnWrite(CW, 'Method    Username   ');
 while not zRetreive(TmpB) do
   begin
     WlnWrite(CW, TmpStr+'     "'+CurrentKey^.who+'"');
     If (Opt and 1)=1 then WWrite(CW, '  <==>   "'+CurrentKey^.key+'"');
   end;
End;

{True on OK}
Function DoInsEncrypt(who:String;  method:Byte;  key:String):Boolean;
var TmpB:Boolean;
Begin
 DoInsEncrypt:=False;
 TmpB:=True;
 while not zRetreive(TmpB) do
   begin
     If UCase(CurrentKey^.who) = UCase(who) then
           begin
             WlnWrite(CW, 'User '+who+' already has a key set');
             exit;
           end;
   end;
 If MemAvail < (SizeOf(KeyEntryREC)*2)+1024 then
   begin
     WlnWrite(CW, 'Insufficient Memory to add key for '+who);
     exit;
   end;

 New(NewKey);
 NewKey^.who := who;
 NewKey^.method := method;
 If not (method in [0,1,2,13]) then NewKey^.method := 0;
 NewKey^.key := key;
 NewKey^.next := nil;

 if FirstKey = nil then FirstKey := NewKey
                   else CurrentKey^.next := NewKey;
 CurrentKey := NewKey;
 DoInsEncrypt := True;
End;


{TRUE on OK}
Function DoDelEncrypt(who : String): Boolean;
var TmpB: Boolean;
    LastKey : KeyEntryPTR;
Begin
   DoDelEncrypt := False;
{   If who='!' then all }
   CurrentKey:=FirstKey;
   If UCase(FirstKey^.who) = UCase(who) then
        begin
          FirstKey := FirstKey^.next;
          Dispose(CurrentKey);
          CurrentKey:=FirstKey;
          DoDelEncrypt:= True;
          exit;
        end;

   LastKey := FirstKey;
   repeat
     If UCase(CurrentKey^.who)=UCase(who) then
         begin
          LastKey^.next := CurrentKey^.next;
          Dispose(CurrentKey);
          CurrentKey := FirstKey;
          DoDelEncrypt:=True;
          break;
         end;
     LastKey := CurrentKey;
     CurrentKey := CurrentKey^.next;
   until CurrentKey = nil;
   CurrentKey := FirstKey;
End;


{ Boolean TRUE on OK }
Function SED_Encrypt( nickchan, StrIn:String; var StrOut:String):Boolean;
var TmpChar:Char;
    I:integer;
    Key:String;
    key_pos, key_len: word;
    Mix:Byte;
    KeyPTR : KeyEntryPTR;
Begin
 SED_Encrypt := False;  StrOut  := '';
 Key     := '';
  KeyPTR  := RetreiveKey(nickchan);
  If KeyPTR = nil then exit;

{  Mix := Ord(key[key_len-1]);   }
 Mix:=0;
 key_pos := 0;
 key_len := Length(KeyPTR^.key);
 key := KeyPTR^.key;

 For i := 1 to Length(StrIn) do
    begin
     TmpChar := StrIn[i];
     StrOut[i] := Chr(Mix  XOR  Ord(TmpChar)   XOR   Ord(Key[key_pos]) );    {^ TmpChar} {^ key[key_pos]}
     Mix := Mix  XOR  Ord(TmpChar);
     key_pos := (key_pos +1 ) MOD  key_len ;       { % key_len }
    end;
 StrOut[0] := Chr(Length(StrIn));

 SED_Encrypt:=True;
End;

{ Boolean TRUE on OK }
Function SED_Decrypt( nickchan, StrIn:String; var StrOut:String):Boolean;
var TmpChar:Char;
    I:integer;
    Key:String;
    key_pos, key_len: word;
    Mix:Byte;
    KeyPTR : KeyEntryPTR;
Begin
  SED_Decrypt := False;  StrOut := '';
  Key     := '';
   KeyPTR  := RetreiveKey(nickchan);
   If KeyPTR = nil then exit;

{  Mix := Ord(key[key_len-1]);    }
  Mix:=0;
  key_pos :=0;
  key_len := Length(KeyPTR^.key);
  key := KeyPTR^.key;

 For i := 1 to Length(StrIn) do
    begin
      TmpChar := Chr( Mix  XOR  Ord(StrIn[i])  XOR  Ord(Key[key_pos])   ); {StrIn[i]}   {key[key_pos]}
      StrOut[i] := TmpChar;
      Mix := Mix XOR Ord(TmpChar);
      key_pos := (key_pos + 1)  MOD  key_len;  { % key_len }
    end;
 StrOut[0] := Chr(Length(StrIn));

  SED_Decrypt:=True;
End;


BEGIN
 FirstKey := nil;  CurrentKey := nil;  NewKey := nil;


END.

