
Unit JPIRCDCC;

Interface

Uses ABI, ABI_DOM, ABI_JP, JP_UNIT, JPIRCVAR, JPIRCWIN, XSTRING, DOS;

CONST   MaxDCCS = 3;
        DCCREQ_TIMEOUT = 300;  {seconds}
        DCC_Off  : Boolean = False;       {To stop Processing DCCs}
        MinimumDCCPort = 512;
        OurDCCBlockSize = 1024;
        ValidCType = [ 'C','F','T' ];

TYPE
   DCREC = RECORD
            State : Byte;
            Status: String;
            S : tcpSessionREC;
            CType : Char;      { F=File, C=Chat, etc }
            CArg  : String[127];
            Initiator : Boolean;             { We Are }
            ReqPending : String[9];    { They say they are}        { If both = then we are active }
            WithUser   : String[9];    { We say they are }
            DCCAddr    : IPAddr;  { Theirs }
            DCCPort    : Word;    { Theirs }
            SizeOfFile : LongInt;
            Received   : LongInt;
            BlockSize  : LongInt;
            DCCFile    : file;
            Buffer : BufferREC;
          END;

var  DCCS : Array[1..MaxDCCS] of DCREC;
     DTo : String[9];
     DMsg: String;

Procedure ProcessDCC_IN(CLine:String);
Procedure ProcessDCC_CMD(CLine:String);
Procedure ProcessAllDCC_Channels;
Procedure ProcessAllDCC_ChatChannels;
Procedure ProcessAllDCC_FileChannels;
Procedure ProcessDCC_Channel(var DCS : DCREC);
Procedure CloseAllDCC;
Procedure CloseDCC(var DCS : DCREC);
Function SizeFile(Fname : string) : longint;

Implementation

var SaveExitProc : Pointer;
    Result:Integer;
    TmpStr:String;
    tDC : Byte;
    Online:Boolean;
    DCC_DebugLog : Text;
    TmpLong:LongInt;
    Counter:Word;

{$F+}
Procedure ULONGstr( ulong:Longint;  var outstr:string); external;  {$L ULONGSTR.OBJ}
{$F-}

Function SizeFile(Fname : string) : longint;
var  sr : SearchRec;
		 idx : integer;
begin
	SizeFile := 0;
	Findfirst(Fname, Anyfile, SR);
	If DosError = 0 then SizeFile := SR.Size ELSE SizeFile := -1;
end;

Procedure ProcessDCC_IN(CLine:String);
var TmpB      :Boolean;
    TmpLong   : LongInt;
    CFirst,CSecond,CThird : String[80];
    CNum      : Word;
    TmpStr, A :String;
    W         : Word;
    tDC       : Byte;  {Matching}
    tFFree    : Byte;  {First Free}
    I, Result : Integer;
BEGIN
   tDC :=0;
   CNum := PARSENFN(CLine);
CFirst := UCase(PARSERFN(CLine, 1));   { Type }
CSecond:= UCase(PARSERFN(CLine, 2));
Writeln(DCC_DebugLog, CLine);

 tFFree:=0;
 For I:=1 to MaxDCCS do
   Begin
     If (not DCCS[I].Initiator) and (DCCS[I].WithUser='') and (DCCS[I].ReqPending='') then tFFree:=I;
     If (DCCS[I].Initiator) and (Ucase(DCCS[I].WithUser)=Ucase(CIN_PNick)) and
        (DCCS[I].ReqPending='') then
           Begin {Confirmation of User Respose to our Initiating of DCC protocol}
             TmpStr:='';
{             DCCS[I].CType:='.'; }
{             If CFirst='CHAT' then DCCS[I].CType:='C';
             If CFirst='FILE' then DCCS[I].CType:='F';     }
             If (CFirst='FILE') and (DCCS[I].CType='F') then
               begin
                 tDC:=I;
                 DCCS[I].State:=0;   DCCS[I].ReqPending:=CIN_PNick;
                 break
               end;
             If (CFirst='CHAT') and (DCCS[I].CType='C') then
               begin
                 tDC:=I;
                 DCCS[I].State:=0;   DCCS[I].ReqPending:=CIN_PNick;
                 break;
               end;
           End;
   End;

If (tDC=0) and (tFFree=0) then
   Begin
    WlnWrite(CW, 'Insufficient DCC Channels available for incoming request');
    exit;
   End;
If (tDC>0) then  { Means *they* are replying to *our* Initiating the DCC connection }
   Begin
(*********
      DCCS[tDC].CType:='.';
      If CFirst='CHAT' then DCCS[tDC].CType:='C';
      If CFirst='FILE' then DCCS[tDC].CType:='F';
**********)
      exit;
   End;

   tDC:=tFFree;
   DCCS[tDC].CType:='.';
   If CFirst='CHAT' then DCCS[tDC].CType:='C';
   If CFirst='FILE' then DCCS[tDC].CType:='F';
   If CFirst='SEND' then DCCS[tDC].Ctype:='F';
   DCCS[tDC].State:=0;
   DCCS[tDC].Status:='REQuest Pending a reply from us!';
   DCCS[tDC].Initiator:=False;
   DCCS[tDC].CArg:=PARSERFN(CLine, 2);
   DCCS[tDC].ReqPending:=CIN_PNick;
   DCCS[tDC].WithUser:='';
   DCCS[tDC].Buffer.Length:=0;
   TmpLong:=Intel(ULVal(PARSERFN(CLine,3)));
   Move(TmpLong, DCCS[tDC].DCCAddr, 4);
(*********
If not ip_lookup(PARSERFN(CLine, 3), DCCS[tDC].DCCAddr) then
    Begin
      WlnWrite(CW, '*!* Unable to determine DCC address');
      exit;
    End;
*****)
TmpStr:=PARSERFN(CLine, 4);
Val( TmpStr, DCCS[tDC].DCCPort, Result);
{ DCCS[tDC].DCCPort:=Intel16(DCCS[tDC].DCCPort);}
If Result<>0 then DCCS[tDC].DCCPort:=0;

If (IPCompare( DCCS[tDC].DCCAddr , NullAddr)) or (DCCS[tDC].DCCPort<MinimumDCCPort) then
      Begin
        WlnWrite(CW, '*!* Invalid Address ['+PARSERFN(CLine,3)+'] or Port ['+TmpStr+']');
        exit;
      End;
TmpStr:=PARSERFN(CLine, 5);
Val( TmpStr, DCCS[tDC].SizeOfFile, Result);
If Result<>0 then DCCS[tDC].SizeOfFile:=0;

Str(DCCS[tDC].DCCPort, TmpStr);
TmpStr:=DCCS[tDC].ReqPending+' '+IPTOASCII(DCCS[tDC].DCCAddr)+':'+TmpStr;
TmpStr:='=== Incoming DCC '+DCCS[tDC].CType+' request from '+TmpStr;
Writeln(DCC_DebugLog, TmpStr);
WlnWrite(CW,TmpStr);

END;


Procedure ProcessDCC_CMD(CLine:String);
var TmpB      :Boolean;
    CFirst,CSecond,CThird : String[80];
    CNum      : Word;
    TmpStr, A :String;
    W         : Word;
    I, Result : Integer;
    TmpLong   : LongInt;
    tFFree, tDC   : Byte;
BEGIN
   CNum := PARSENFN(CLine);
   Writeln(DCC_DebugLog, 'CLine=',CLine);
   CFirst := UCase(PARSERFN(CLine, 1));
   CSecond:= UCase(PARSERFN(CLine, 2));
   CThird := UCase(PARSERFN(CLine, 3));
If (CNum =0) or (CFirst='LIST') or (CFirst='DCC') then
     Begin
{       WlnWrite(CW, '*** DCC Status display is not implemented at this moment'); }
       WlnWrite(CW, '*** DCC Status Listing');
       Writeln(DCC_DebugLog, '*** DCC Status Listing');
       WlnWrite(CW, 'Channel');
      {12345678901234567890123456789012345678901234567890123456789012345678901234567890}
      {00CI  1234  131.202.3.10                                                                                 }
       For I:=1 to MaxDCCS do
         begin
{          If DCCS[I].CType in ValidCType then
            Begin                              }
              Str(DCCS[I].BlockSize:5, TmpStr);
              CThird:=LeadingZero(I,2);
              If DCCS[I].S.Openned Then CThird:=CThird+''  else CThird:=CThird+'x';
              CThird:=CThird+DCCS[I].CType;
              If DCCS[I].Initiator then CThird:=CThird+'I '  else CThird:=CThird+'r ';
              TmpStr:=CThird+TmpStr+'  '+IPTOASCII(DCCS[I].DCCAddr)+':';
              Str(DCCS[I].DCCPort, CThird);
              TmpStr:=TmpStr+CThird+'  "'+DCCS[I].ReqPending+'", "'+DCCS[I].WithUser+'"';
              Str(DCCS[I].SizeOfFile, A);
              Str(DCCS[I].Received, CThird);
              Writeln(DCC_DebugLog, TmpStr+', FileSize='+A+', Received='+CThird);
              WlnWrite(CW, TmpStr+', FileSize='+A+', Received='+CThird);
{            End; }
         end;
       WlnWrite(CW, '~~~ end of listing');
       WriteLn(DCC_DebugLog, '~~~ end of listing');
       exit;
     End;

If (CFirst = 'CLOSE') or (CFirst='KILL') then
     Begin
       For I:=1 to MaxDCCS do
         Begin
           If Ucase(DCCS[I].WithUser) = CSecond then
               begin
                 CloseDCC(DCCS[I]);
                 WlnWrite(CW, '*!*  DCC connection with '+DCCS[I].WithUser+' Closed');
                 break;
               end;
         End;
       A:=CSecond;
       If Copy(A,1,1)<>'=' then A:=''  else Delete(A,1,1);
       If (A='ALL') then
           Begin
            CloseAllDCC;
            WlnWrite(CW, '*!*  All DCC connections closed');
            exit;
           End;
       If (A='CHAT') then
           Begin
            For I:=1 to MaxDCCS do
               begin
                 If DCCS[I].CType='C' then
                  Begin
                   CloseDCC(DCCS[I]);
                   WlnWrite(CW, '*!*  DCC CHAT connection with '+DCCS[I].WithUser+' Closed');
                  End;
               end;
            exit;
           End;
       If (A='FILE') then
           Begin
            For I:=1 to MaxDCCS do
               begin
                 If DCCS[I].CType='F' then
                  Begin;
                   CloseDCC(DCCS[I]);
                   WlnWrite(CW, '*!*  DCC FILE connection with '+DCCS[I].WithUser+' Closed');
                  End;
               end;
            exit;
           End;
       If Length(A)>0 then
         begin
           Val(A, W, Result);
           If Result<>0 then W:=0;
         end;
       If (W>0) and (W >= MaxDCCS) then
         begin
           WlnWrite(CW, '*!*  DCC CHAT connection with '+DCCS[W].WithUser+' Closing');
           CloseDCC(DCCS[W]);
         end;
       exit;
     End;  {/DCC CLOSE}

WlnWrite(CW, CLine+', "'+CFirst+'"');
If (CFirst = 'CHAT') and (CNum>1) then
     Begin
       TmpStr:=TmpStr+'CHAT chat ';
       Writeln(DCC_DebugLog, 'Doing local cmd chat thing');
       tDC:=0;
       tFFree:=0;
       For I:=1 to MaxDCCS do
         BEGIN
           If (not DCCS[I].Initiator) and (DCCS[I].WithUser='') and (DCCS[I].ReqPending='') then tFFree:=I;
           Writeln(DCC_DebugLog, UCase(DCCS[I].ReqPending),'=',UCase(PARSERFN(CLine,2)),',  "',DCCS[I].WithUser,'"');
           If (UCase(DCCS[I].ReqPending)=UCase(PARSERFN(CLine,2))) and
              (DCCS[I].WithUser='') then
                Begin                      { Our responding to a DCC request }
                 TmpStr:='';
                 If DCCS[I].CType='C' then TmpStr:='CHAT';
                 If CFirst=TmpStr then
                     begin
                        tDC:=I;
                        DCCS[I].State:=0;    DCCS[I].WithUser:=PARSERFN(CLine,2);
                        Writeln(DCC_DebugLog, 'We found his request and we are going to attach to it');
                        WlnWrite(CW, 'Found previous request');
                        break;
                     end;
                End;
         END;
       If (tDC=0) and (tFFree=0) then
          Begin
            WlnWrite(CW, 'Insufficient DCC Channels available to create a DCC CHAT REQ');
            exit;
          End;
       If tDC>0 then  {Means *we* are replying to *their* DCC request }
           Begin
             WlnWrite(CW, 'This means we are replying.  But are we really?');
             exit;
           End;
       tDC:=tFFree;
       DCCS[tDC].CType:='C';
       DCCS[tDC].Status:='Waiting for reply from other end!';
       DCCS[tDC].Initiator:=True;
       DCCS[tDC].CArg:='chat';
       DCCS[tDC].ReqPending:='';
       DCCS[tDC].WithUser:=PARSERFN(CLine,2);
       DCCS[tDC].Buffer.Length:=0;
       Result:=tcp_open(DCCS[tDC].S, 1, NullAddr, 0, 0, 0);
       if Result<>0 then
         begin
           WlnWrite(CW, 'Error openning local port for chat request');
           If DCCS[tDC].S.openned then Result:=tcp_Close(DCCS[tDC].S, 0, 150);
         end;
       Move(DCCS[tDC].S.Status.ip_srce, TmpLong, 4);
       ULongStr(Intel(TmpLong), TmpStr);
{       TmpStr:=ULStr(Intel(Tmplong)); }
       Str(DCCS[tDC].S.Status.port_srce, A);

       If Online then
         begin
           A:='PRIVMSG '+DCCS[tDC].WithUser+' :'+^A+'DCC CHAT chat '+TmpStr+' '+
              A+^A;
           WlnWrite(CW,'Sending DCC chat request: "'+A+'"');
           tcp_sendtextln(IRCS, A);
         end;
       {if Online then tcp_sendtextln(IRCS, A); }
       {*SEND CHAT REQ incomplete*}
     End;
If {(CFirst = 'RAW') or} (CFirst = 'MSG') then
     Begin
      DTo:=CSecond;
      DMsg:=PARSERREST(CLine,3);
     End;
If (CFirst = 'SEND') and (CNum>2) then
     Begin                              { /DCC SEND user <filename> }
      TmpStr:=TmpStr+'SEND '+PARSERREST(CLine,3);
     End;
If ((CFirst='RECEIVE') or (CFirst='RCV') or (CFirst='GET')) and (CNum>2) then
     Begin                              { /DCC GET user [<filename>] }
      TmpStr:='';
      Writeln(DCC_DebugLog, 'Doing local cmd get thing');
      tFFree:=0;
      For I:=1 to MaxDCCS do
        BEGIN
          If (not DCCS[I].Initiator) and (DCCS[I].WithUser='') and (DCCS[I].ReqPending='') then tFFree:=I;
          Writeln(DCC_DebugLog, UCase(DCCS[I].ReqPending),'=',UCase(PARSERFN(CLine,2)),',  "',DCCS[I].WithUser,'"');
           If (UCase(DCCS[I].ReqPending)=UCase(PARSERFN(CLine,2))) and
              (DCCS[I].WithUser='') and (DCCS[I].CType='F') then
                Begin                      { Our responding to a DCC request }
                       tDC:=I;
                       DCCS[I].State:=0;    DCCS[I].WithUser:=PARSERFN(CLine,2);
                       Writeln(DCC_DebugLog, 'We found his file send ch and we are going to attach to it');
                       DCCS[I].CArg:=PARSERFN(CLine,3);
                       Assign(DCCS[I].DCCFile, DCCS[I].CArg);
                       FileMode:=2;
                       ReWrite(DCCS[I].DCCFile, 1);
                       break;
                End;
        END;

     End;

END;


Procedure ProcessDCC_Channel(var DCS : DCREC);
var  tLong:LongInt;
Begin

 If (DCC_Off) then
   begin
    DTo:='';
    DMsg:='';
    exit;
   end;
 If (DCS.WithUser='') or (DCS.ReqPending='') then exit;

(******
If DCS.S.Openned then
  Begin
    Result:=tcp_status(DCS.S, 0);
    If Result=6 then DCS.State:=13;
    If Result=4 then
        begin
          WlnWrite(CW, 'bad handle with DCC, Nuking DCS channel');
          FillChar(DCS, SizeOf(DCS), #0);
          exit;
        end;
  End;
********)
CASE DCS.CType of
  'C' : BEGIN
            Case DCS.State of
              0  : Begin
                     result:=tcp_open(DCS.S, 0, DCS.DCCAddr, 0, DCS.DCCPort, 275);
                     Str(DCS.DCCPort, Tmpstr);
                     Writeln(DCC_DebugLog, 'Openning DCS channel: '+
                                           IPTOASCII(DCS.DCCAddr)+':'+TmpStr);
                     Str(result, TmpStr);
                     Writeln(DCC_DebugLog, 'Openned DCS channel with result as '+TmpStr);
                     If result<>0 then
                           begin
                             Str(result, TmpStr);
                             TmpStr:='Error Openning DCC port.  Error #'+TmpStr;
                             WlnWrite(CW, TmpStr);
                             Writeln(DCC_DebugLog, 'State0 - ',TmpStr);
                             DCS.State:=13;
                             If Result>5 then
                                   begin
                                     Result:=4;
                                     If (DCS.S.Handle>1) and DCS.S.Openned then Result:=tcp_close(DCS.S, 0, 150);
                                     FillChar(DCS, SizeOf(DCS), #0);
                                   end;
                             WlnWrite(CW, 'DCS Channel nuked');
                             FillChar(DCS, SizeOf(DCS), #0);
                             DTo:='';  DMsg:='';
                             exit;
                           end;
                     DCS.State:=1;
                   End;
              1  : Begin
                     If ReadlnBuff(DCS.S, DCS.Buffer) then
                        begin
            {              WlnWrite(CW, '*DCC*'+DCS.WithUser+'*');}
                          If DCS.Buffer.length>0 then
                              begin
                                Write(DCC_DebugLog, 'DCS.BUFFER=');
                                For I:=1 to DCS.Buffer.Length do
                                   Write(DCC_DebugLog, DCS.Buffer.Buffer[I]);
                                   Writeln(DCC_DebugLog,'***');
                              end;
                          WlnWrite(CW, DCS.WithUser+'* ');
                          WlnAWrite(CW, DCS.Buffer);
                       end;
                     If UCase(DCS.WithUser)=UCase(DTo) then
                         Begin
                            WlnWrite(CW, 'Message Sent: '+DMsg);                     {ENCRYPT}
                            if Length(DMsg)>0 then tcp_sendtextln(DCS.S, DMsg);
            {
                                AddBuffer(DCS.Buffer, 1, DMsg);
                                repeat
                                until WritelnBuff(DCS.S) or IsScrLock;
            }
                          End;
              {          end;}
                    If DCS.S.Status.State<>4 then
                            begin
                             DMsg:='';
                             WlnWrite(CW, '*** DCC Connection closed');
                             DCS.State:=13;
                            end;
                   End;
              2  : ;
              3  : ;
              4  : ;
              5  : ;
              6  : ;
              7  : ;
              13 : Begin
                     Result:=4;
                     If DCS.S.Handle<>0 then Result:=tcp_close(DCS.S, 0, 150);
                     Str(DCS.DCCPort, TmpStr);
                     TmpStr:='DCC connection with '+IPTOASCII(DCS.DCCAddr)+':'+TmpStr+
                             ' closed via DCS.State13';
                     WlnWrite(CW, TmpStr);
                     Write(DCC_DebugLog, TmpStr);
                     FillChar(DCS, SizeOf(DCS), #0);
                   End;  {Begin 13}
             End;   {Case DCS.State}
          END;  {Begin 'C'}
  'F' :   BEGIN
            If DCS.Initiator then
              Begin
               Writeln('Unimplemented - DCC Send file');
                Case DCS.State of
                  13 : Begin
                         Result:=4;
                         If DCS.S.Handle<>0 then Result:=tcp_close(DCS.S, 0, 150);
                         Str(DCS.DCCPort, TmpStr);
                         TmpStr:='DCC connection with '+IPTOASCII(DCS.DCCAddr)+':'+TmpStr+
                                 ' closed via DCS.State13';
                         WlnWrite(CW, TmpStr);
                         CloseDCC(DCS);
                         Write(DCC_DebugLog, TmpStr);
                       End;  {Begin 13}
                End;
             End Else Begin
                Case DCS.State of
                  0  : Begin
                         result:=tcp_open(DCS.S, 0, DCS.DCCAddr, 0, DCS.DCCPort, 275);
                         FileMode:=2;
                         Str(DCS.DCCPort, Tmpstr);
                         Writeln(DCC_DebugLog, 'Openning DCS channel: '+
                                               IPTOASCII(DCS.DCCAddr)+':'+TmpStr);
                         Str(result, TmpStr);
                         Writeln(DCC_DebugLog, 'Openned DCS channel with result as '+TmpStr);
                         If result<>0 then
                               begin
                                 Str(result, TmpStr);
                                 TmpStr:='Error Openning DCC port.  Error #'+TmpStr;
                                 WlnWrite(CW, TmpStr);
                                 Writeln(DCC_DebugLog, 'State0 - ',TmpStr);
                                 DCS.State:=13;
                                 If Result>5 then
                                       begin
                                         Result:=4;
                                         If DCS.S.Handle<>0 then Result:=tcp_close(DCS.S, 0, 150);
                                         FillChar(DCS, SizeOf(DCS), #0);
                                       end;
                                 WlnWrite(CW, 'DCS Channel nuked');
                                 FillChar(DCS, SizeOf(DCS), #0);
                                 DTo:='';  DMsg:='';
                                 exit;
                               end;
                         DCS.State:=1;
                         DCS.Received:=0;
 {HEREFILE}            End;
                  1  : Begin
                        If (DCS.S.Status.State<>4) or IsScrLock then
                                begin
                                 DMsg:='';
                                 WlnWrite(CW, '*** DCC Connection closed');
                                 DCS.State:=13;
                                end;
                         DCS.S.Buffer.Length:=0;
                         DCS.Buffer.Length:=0;
                         Result:=tcp_get(DCS.S, 1, 0);
                         If DCS.S.Buffer.Length>0 then DCS.State:=2
                                                  else DCS.State:=3;
                       End;
                  2  : Begin
                          WWrite(CW, '');
                          If DCS.S.Buffer.length>0 then
                              begin
(**********
                                Write(DCC_DebugLog, 'DCS.BUFFER=');
                                For I:=1 to DCS.S.Buffer.Length do
                                   Write(DCC_DebugLog, DCS.Buffer.Buffer[I]);
                                   Writeln(DCC_DebugLog,'***');
*************)
                                BlockWrite(DCS.DCCFile, DCS.S.Buffer.Buffer, DCS.S.Buffer.Length, Result);
                                DCS.Received:=DCS.Received + DCS.S.Buffer.Length;
                                If Result=0 then
                                     Begin
                                       Str(Result, TmpStr);
                                       Writeln(DCC_DebugLog, 'Bytes to go to   file was:  ', DCS.S.Buffer.Length);
                                       Writeln(DCC_DebugLog, 'Bytes written to file was:  ', Result);
                                       WlnWrite(CW, '!!! Error BlockWriting received packet ['+TmpStr+']');
 {                                      DCS.State:=13;     }
                                     End;
                                DCS.State:=1;
                              end;

                       End;
                  3  : Begin
{
                              Str(DCS.Received,TmpStr);
                              WWrite(CW, ''+TmpStr+'');
                              Writeln(DCC_DebugLog, ''+TmpStr+'');
}
                              tLong:=Intel(DCS.Received);
                              Move(tLong, TmpStr[1], 4);
                              TmpStr[0]:=#4;
                              tcp_sendtext(DCS.S, TmpStr);
                              DCS.State:=4;
                       End;
                  4  : Begin
                        If (DCS.S.Status.State<>4) or IsScrLock then
                                begin
                                 DMsg:='';
                                 WlnWrite(CW, '*** DCC Connection closed');
                                 DCS.State:=13;
                                end;
                         DCS.S.Buffer.Length:=0;
                         DCS.Buffer.Length:=0;
                         DelayMS(100);
                         Result:=tcp_get(DCS.S, 1, 0);
                         If Result<>0 then WlnWrite(CW, 'Result is not zero in State4, tcp_get');
                         If DCS.S.Buffer.Length>0 then DCS.State:=2;
                       End;
                  5  : ;
                  6  : ;
                  7  : ;
                  13 : Begin
                         Result:=4;
{                         If DCS.S.Handle<>0 then Result:=tcp_close(DCS.S, 0, 150); }
                         Str(DCS.DCCPort, TmpStr);
                         TmpStr:='DCC connection with '+IPTOASCII(DCS.DCCAddr)+':'+TmpStr+
                                 ' closed via DCS.State13';
                         WlnWrite(CW, TmpStr);
                         CloseDCC(DCS);
                         DCS.State := 0;
                         Write(DCC_DebugLog, TmpStr);
                       End;  {Begin 13}
                 End;   {Case DCS.State}
              End; {else begin}
          END; {Begin 'F'}
   END;

 DTo:='';
 DMsg:='';
 If (not DCS.S.Openned)    then
   begin
     DTo:='';
     DMsg:='';
     exit;
   end;


End;


Procedure ProcessAllDCC_ChatChannels;
Begin
 If DCC_Off then exit;
 For tDC:=1 to MaxDCCS do
  begin
    If (DCCS[tDC].CType='C') then ProcessDCC_Channel(DCCS[tDC]);
  end;
End;

Procedure ProcessAllDCC_FileChannels;
Begin
 If DCC_Off then exit;
 For tDC:=1 to MaxDCCS do
  begin
    If (DCCS[tDC].CType='F') then ProcessDCC_Channel(DCCS[tDC]);
  end;
End;

Procedure ProcessAllDCC_Channels;
BEGIN
 If DCC_Off then exit;
 ProcessAllDCC_ChatChannels;
 ProcessAllDCC_FileChannels;
END;

Procedure CloseDCC(var DCS : DCREC);
Begin
{ If (DCS.State=0) and (not DCS.S.Openned) then exit;  }
{ If not DCS.S.Openned then exit;                      }
 If DCS.S.Openned then
   begin
     Result:=4;
     If (DCS.S.Handle>1) then Result:=tcp_close(DCS.S, 0, 150);
     If (DCS.CType='F') and (DCS.State>0) then Close(DCS.DCCFile);
   end;
 FillChar(DCS, SizeOf(DCS), #0);
 DCS.CType:='.';
End;

Procedure CloseAllDCC;
Begin
 For tDC:=1 to MaxDCCS do
  begin
    CloseDCC(DCCS[tDC]);
    DCCS[tDC].CType:='.';
  end;
End;



{$F+}
Procedure DCC_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   CloseAllDCC;
   Close(DCC_DebugLog);
   If SizeFile('DCC.LOG') = 0 then Erase(DCC_DebugLog);
 end;


BEGIN
  FillChar(  DCCS, SizeOf(DCCS), #0);

  Assign(DCC_DebugLog, 'DCC.LOG');
   SaveExitProc:=ExitProc;
   ExitProc:=@DCC_NewExitProc;
  ReWrite(DCC_DebugLog);
  CloseAllDCC;

END.    (C) 1997 - Copyright ParSoft, by Jeff Patterson

