
Unit JPIRCVAR;

Interface

Uses DOS,ABI,JP_UNIT, CompDate, Country,
{$IFDEF OVERLAY}
     OVERLAY,
{$ENDIF}
     INI_MGR;

{$I TCP.INC}

(****************************

Note:   {}|    is lowercase equivalent of []\
        IRC Message must not exceed 512 chrs in length (including CRLF)


****************************)

CONST  ClientName: String[5] = 'JPIRC';
       ClientVer : String[10] = '0.98.95bx';
       ClientEnv : String[60] = 'Compiled using Borland''s Turbo Pascal v7.0 under MS-DOS 6.22';
       ClientAuthor : String[35] = 'Jeff Patterson <aa093@fan.nb.ca>';
       ClientSourceFTPHost : String[ 4] = 'none';
       ClientSourceFTPDir  : String[ 4] = 'none';
       ClientSourceFTPFiles : String[15] = 'none none none';
CONST MaxChannels = 5;
      INIFileName = 'JPTCP.INI';

TYPE

UserREC = RECORD
            Nick        : String[30];  { was 9 }
            Pass        : String[30];
            WeAway      : Boolean;
            username    : String[16];
            hostname    : String[127];
            servername  : String[127];
            serverIP    : IPAddr;
            serverPort  : Word;
            realname    : String[127];
            UserInfo    : String[225];
            ClientInfo  : String[225];
            PGPInfo     : String[225];
            IRCop       : Boolean;
            i           : Boolean;
            s           : Boolean;
            w           : Boolean;
            o           : Boolean;
            r           :  Boolean; {Restricted}
            RegdIn      : Boolean;
         END;


ChannelREC = RECORD
               Name  :String[200];  {Starts with & or #} { No #32, #7 or ',' }
               Topic :String[255];
               o :Boolean; { User Mode, Chan-Op}
               v :Boolean; { User Mode, Voice}
               LogRcv   :Byte;
               p :Boolean; { private channel flag}
               s :Boolean; { secret channel flag}
               i :Boolean; { invite-only channel flag}
               t :Boolean; { topic settable by channel operator only flag}
               n :Boolean; { no messages to channel from clients on the outside}
               m :Boolean; { moderated channel}
               UserLimit    : Word;          {l}
               Key          : String[255];   {k} {255 for now}
               TimeChannel : LongInt;
               TimeTopic   : LongInt;
            END;
   pChannelRec = Array[0..MaxChannels] of ChannelRec;


var
  CHA           : ^pChannelREC;
  X_N_CLN :String;
  X_N_SPC :String;

  IRCS       : TcpSessionREC;        {Main IRC Session}
  User       : UserREC;              {User Record}
  CCH        : Byte;             {Current Channel ?Dont need this?}
  Online     : Boolean;
  NormalExit : Boolean;
  AutoRegister:Boolean;
  BeStrictD   :Boolean;
  ExitFirstQuit : Boolean;
  TcpOpenTime   : Word;
  OurVersion    : String[100];
  ClientDate    : String[20];
  QOTDServer    : String[80];
  DefaultServer : String[80];
  DefaultPort   : Word;
  TrumpetBusy   : Boolean;
  tf        : text;              { ** -file startup ** }
  DebugLog  : text;
  DebugLogFlag : Boolean;

  CIN_Buff  :BufferREC;
  CIN_Valid :Boolean;
  CIN_Line  :String;
  CIN_prefix:String;
  CIN_PUser  :String;      {Prefix-processed user}
  CIN_PNick  :String;
  CIN_PAddr  :String;  {Server}
  CIN_PHost  :String;

  LastPRIVMSG : String[20];

{ Procedure InitVars; }
Procedure tcp_sendtextln(var S:tcpSessionREC; ToSend:String);
Function GetUnixTime : LongInt;

function PARSENFN (sj : string) : integer;
function PARSERFN (sj : string; PartNumber : integer) : string;
function PARSERREST (sj : string; PartNumber : integer) : string;

Function  WasTrueFalse (ToCheck :String):Boolean;

Implementation

Uses DTIME;

Function  WasTrueFalse (ToCheck :String):Boolean;
var tStr:String;
Begin
 WasTrueFalse:=False;
 tStr:=Ucase(PARSERFN(ToCheck, 1));
 If (tStr='1') or (tStr='YES') or (tStr='TRUE') or (tStr='ON') or (tStr='Y') or
    (tStr='2') or (tStr='3')  then WasTrueFalse:=True;
End;

(* Number of substrings in a string *)
function PARSENFN (sj : string) : integer;
var i, n, p : integer;
begin
  p := Length(sj);
  n := 0;
  i := 1;
  repeat
    while (sj[i] {<} = #32) and (i <= p) do Inc(i);     {changed}
    if i > p then begin parsenfn := n; exit; end;
    while (sj[i] <> #32) and (i <= p) do Inc(i);        {changed}
    Inc(n);
    if i > p then begin parsenfn := n; exit; end;
  until false;
end;  (* parsenfn *)

(* Get substrings from a string *)
function PARSERFN (sj : string; PartNumber : integer) : string;
var i, j, n, p : integer;
    stash      : string;
begin
  if (PartNumber < 1) or (PartNumber > PARSENFN(sj)) then
    begin PARSERFN := ''; exit; end;
  p := Length(sj);
  n := 0;
  i := 1;
  repeat
    while (sj[i] { < } = #32) and (i <= p) do Inc(i);    {changed here}
    Inc(n);
    if n = PartNumber then
      begin
        j := 0;
        while (sj[i] <> #32) and (i <= p) do             {changed here}
          begin
            Inc(j);
            stash[0] := chr(j);
            stash[j] := sj[i];
            Inc(i);
          end;
        PARSERFN := stash;
        exit;
      end
     else
       while (sj[i] <> #32) and (i <= p) do Inc(i);     {changed here}
  until false;
end;  (* parserfn *)

function PARSERREST (sj : string; PartNumber : integer) : string;
var
  TmpStr:String;
  I,J:Integer;
begin
   TmpStr:='';
   J:=PARSENFN(sj);
   For I:=PartNumber to J do
       begin
         TmpStr:=TmpStr+PARSERFN(sj, I);
         If I<>J then TmpStr:=TmpStr+' ';
       end;
   If Copy(TmpStr,1,1)=':' then Delete(TmpStr,1,1);                      {*HERE*}
   PARSERREST:=TmpStr;
end;  (* parserrest *)


Procedure tcp_sendtextln(var S:tcpSessionREC; ToSend:String);
 begin
   AddBuffer(S.Buffer, 0, ToSend);
   tcp_Put(S, 6, 5000);
   { If Timeout then close the connection }
 end;

Function GetUnixTime : LongInt;
var Y,M,D,H,Min,S,DOW,s100:Word;
Begin
  GetDate(Y,M,D,DOW);
  GetTime(H,Min,S,s100);
  GetUnixTime := Norm2Unix(Y,M,D,H,Min,S);
End;

Procedure InitVars;
var TmpB:Boolean;
    FAP : FieldType;
Begin
       X_N_CLN := ClientName+':'+ClientVer+' '+CompileDate+':'+ClientEnv;
       X_N_SPC := ClientSourceFTPHost+':'+ClientSourceFTPDir+':'+ClientSourceFTPFiles;
       OurVersion := ClientName+' '+ClientVer+' (internal version '+CompileDate+')';
       ClientDate := CompileDate;
       Online  := False;
       TcpOpenTime  := 450;
       AutoRegister := False;
       BeStrictD    := False;
       ExitFirstQuit:= False;

       FillChar(IRCS, Sizeof(IRCS), #0);
       FillChar(CHA^ , Sizeof(CHA^), #0);
       LastPRIVMSG :='';
    User.Nick    :='ircuser';
    User.Pass    :='';
    User.UserName:='root';
    User.HostName:='.';
    User.ServerName:='';  User.ServerPort:=6667;
    User.RealName:='Anonymous';
    DefaultServer:='irc.mis.ca';  DefaultPort:=6667;

   FAP.Field:='DebugLogFlag';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then DebugLogFlag:=WasTrueFalse(FAP.Value);

   FAP.Field:='Nick';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.Nick:=FAP.Value;

   FAP.Field:='UserName';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.Username:=FAP.Value;

   FAP.Field:='HostName';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.HostName:=FAP.Value;
{   User.HostName:='.'; }

   FAP.Field:='DefaultServer';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then
     begin
      DefaultServer:=FAP.Value;
      User.ServerName:=FAP.Value;
     end;

   FAP.Field:='DefaultPort';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then
     begin
       Val(FAP.Value, User.ServerPort, Result);
       If Result<>0 then User.ServerPort:=6667;
       DefaultPort:=User.ServerPort;
     end;

   FAP.Field:='TcpOpenTime';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then
     begin
       Val(FAP.Value, TcpOpenTime, Result);
       If Result<>0 then TcpOpenTime:=550;
     end;

   FAP.Field:='RealName';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.RealName:=FAP.Value;

   FAP.Field:='UserInfo';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.UserInfo:=FAP.Value;

   FAP.Field:='ClientInfo';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.ClientInfo:=FAP.Value;
   User.ClientInfo:='ACTION ECHO FINGER CLIENTINFO DCC USERINFO VERSION SOURCE PGPINFO'+
                    ' :Are the current CTCP commands understood by this IRC client';

   User.PGPInfo:='none:none:none';
   FAP.Field:='PgpInfo';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then User.PGPInfo:=FAP.Value;

   FAP.Field:='AutoRegister';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then AutoRegister:=WasTrueFalse(FAP.Value);

   FAP.Field:='QOTD';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then QOTDServer:=FAP.Value;

   FAP.Field:='BeStrictD';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then BeStrictD:=WasTrueFalse(FAP.Value);

   FAP.Field:='ExitFirstQuit';   FAP.Value:='';
   LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
   If FAP.Value<>'' then ExitFirstQuit:=WasTrueFalse(FAP.Value);

End;

var
  SaveExitProc:Pointer;
  FirstMemAvail : LongInt;

{$F+}
Procedure VAR_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   Dispose(CHA);
   If NormalExit then
     begin
       Writeln;
     end;
 end;


BEGIN
  New(CHA);
  FirstMemAvail:=MemAvail;
  TrumpetBusy := False;
  NormalExit:=False;
  SaveExitProc:=ExitProc;
  ExitProc:=@VAR_NewExitProc;
  FillChar(User, SizeOf(User), #0);
{$IFDEF OVERLAY}
  OvrInit('JPIRC.OVR');
{$ENDIF}
  InitVars;
  IRCS.DAT.ReadCRLF:=True;
END.

