
Unit JPIRCWIN;

Interface

Uses DOS,CRT,JP_UNIT,XSTRING,MkScrn,ABI,ABI_JP,
     DTIME,JPIRCVAR;


CONST   SpecialChr = [#0..#31, #255];
        MaxWindows = 2;

TYPE
  sLastLogFlags = (Lpublic, Lmsgs, Lnotices, Lwalls, Lwallops, Lnote,
                   Lopnotes, Lsnotes, Lactions, Luserlog1, Luserlog2,
                   Luserlog3, Luserlog4, Ldcc, Lcrap);

   WindowRec = RECORD
                Y1:Byte;
                Y2:Byte;
                CX:Byte;
                CY:Byte;
                SY1:Byte;
                SY2:Byte;
                tA : Word;
                Logging:Boolean;
                Notifying:Boolean;
                Hold:Boolean;
                LastLog:Word;                       {lines of lastlog}
                LastLog_Level:set of sLastLogFlags;
                Notify_Level :set of sLastLogFlags;
                LogFileName:String[127];
                CCH:Byte;
                SplitFrom:Byte;
              END;
   pWindowREC = Array[0..MaxWindows] of WindowRec;

var
  WindowA       : ^pWindowREC;
  StatLine      : String[80];
  Spinner       : Integer;

  DoChkMail     : Boolean;
  NumMailMsgs   : LongInt;
  NewMail       : LongInt;
  Mailother     : Char;

  MenuBarLU     : Word;
  MenuBar_sa, MenuBar_sa100 : Word;
  CW            : Byte;
  InsertMode    : Boolean;  {used by JPIRC_IO ONLY!  NOT FOR WINDOW!}
  TmpX, TmpY, TmpA : Byte;
  TmpB:Boolean;
  AttrB_ON       : Boolean;
  AttrV_ON       : Boolean;
  Attr__ON       : Boolean;

  ScanBack:String[20];

Procedure InitDisplay;
Procedure ShowStatusLine(CWindow:Byte;  Other:String);
Procedure WWrite(CWindow:Byte; ToWrite:String);
Procedure WlnWrite(CWindow:Byte; ToWrite:String);
Procedure WAWrite(CWindow:Byte; CB:BufferRec);
Procedure WlnAWrite(CWindow:Byte; CB:BufferRec);
Procedure AbsGotoXY(TmpX,TmpY:Byte);
Function AbsWhereX:Byte;
Function AbsWhereY:Byte;
Function MySaveScrnRegion(xl,yl,xh,yh: Byte; Var Pt: Pointer):Word;
Procedure MyRestoreScrnRegion(xl,yl,xh,yh: Byte; Var Pt: Pointer; Var tWord:Word);
Function WordWrap(var S: String;  Max: Byte): String;
Procedure ShowUnixDate(Date:LongInt);

Implementation

Procedure ShowUnixDate(Date:LongInt);
var Y,M,D,H,Min,S : Word;
    A : String;
Begin
 Unix2Norm(Date, Y,M,D,H,Min,S);
 Str(Y:4, A);
 A:=LeadingZero(M,2)+'/'+LeadingZero(D,2)+'/'+A+'  '+LeadingZero(H,2)+':'+LeadingZero(Min,2)+':'+LeadingZero(S,2);
 WWrite(CW,A);
End;

Function WordWrap(var S: String;  Max: Byte): String;
var T:String;
Begin
  T := '';
  while (Length(S) > Max) or
        (not(S[Length(S)] in [#0,#9,#32,#160,#255])) do begin
     T := S[Length(S)] + T;
     Delete(S, Length(S),1);
  end;
  while (S[Length(S)] in [#0,#9,#32,#160,#255]) do Delete(S,Length(S),1);
  WordWrap := T; { S[0]=0 loop?  this might act stupid}
End;

Function MySaveScrnRegion(xl,yl,xh,yh: Byte; Var Pt: Pointer):Word;
  Var
    Tx, Ty: Byte;
    Ctr: Word;
  Begin
  GetMem(Pt, ((xh + 1 - xl) * (yh +1 - yl) * 2));
  If Pt = nil Then
    MySaveScrnRegion := 0
  Else
    Begin
    MySaveScrnRegion := ((xh + 1 - xl) * (yh +1 - yl) * 2);
    Ctr := 0;
    For Tx := xl to xh Do
      Begin
      For Ty := yl to yh Do
        Begin
        WordArrayPtr(PT)^[Ctr] := GetScrnWord(Tx, Ty);
        Inc(Ctr);
        End;
      End;
    End;
  End;

Procedure MyRestoreScrnRegion(xl,yl,xh,yh: Byte; Var Pt: Pointer; Var tWord:Word);
  Var
    Tx, Ty: Byte;
    Ctr: Word;
  Begin
  If Pt <> nil Then
    Begin
    Ctr := 0;
    For Tx := xl to xh Do
      Begin
      For Ty := yl to yh Do
        Begin
        PutScrnWord(Tx, Ty, WordArrayPtr(PT)^[Ctr]);
        Inc(Ctr);
        End;
      End;
    FreeMem(Pt, tWord);
    End;
  End;



Procedure AbsGotoXY(TmpX,TmpY:Byte);
Begin
 SetCursorPosition(TmpX, TmpY);
End;

Function AbsWhereX:Byte;
var tX,tY:byte;
Begin
 GetCursorPosition(tX,tY);
 AbsWhereX:=tX;
End;

Function AbsWhereY:Byte;
var tX,tY:byte;
Begin
 GetCursorPosition(tX,tY);
 AbsWhereY:=tY;
End;

Procedure InitDisplay;
 Begin
   FillChar(WindowA^, SizeOf(WindowA^), #0);
   FillChar(StatLine[1],80, #32); StatLine[0]:=#80;
   WindowA^[0].Y1:=1;  WindowA^[0].Y2:=23;  WindowA^[0].SY1:=24; WindowA^[0].SY2:=24;
   WindowA^[0].CX:=1;  WindowA^[0].CY:=1;   WindowA^[0].tA :=7;
   WindowA^[0].Logging:=False;  WindowA^[0].Notifying:=False;  WindowA^[0].Hold:=False;
   WindowA^[0].LastLog:=44;  WindowA^[0].LogFileName:='IrcLog';
   WindowA^[0].LastLog_Level:=[Lpublic] + [Lmsgs] + [Lnotices] + [Lwalls] +
                             [Lwallops] + [Lnote] + [Lopnotes] + [Lactions] +
                             [Luserlog1] + [Luserlog2] + [Luserlog3] +
                             [Luserlog4] + [Ldcc] + [Lcrap];
   WindowA^[0].Notify_Level:=WindowA^[0].LastLog_Level;
   WindowA^[1].Y1:=1;  WindowA^[1].Y2:=23;  WindowA^[1].SY1:=24; WindowA^[1].SY2:=24;
   WindowA^[1].CX:=1;  WindowA^[1].CY:=1;
   WindowA^[1].Logging:=False;  WindowA^[1].Notifying:=False;  WindowA^[1].Hold:=False;
   WindowA^[1].LastLog:=44;  WindowA^[1].LogFileName:='IrcLog';
   WindowA^[1].LastLog_Level:=WindowA^[0].LastLog_Level;
   WindowA^[1].Notify_Level :=WindowA^[0].LastLog_Level;
   WindowA^[1].tA :=7;
   CW:=1;
   DirectVideo:=True;  CheckSnow:=False;
   NormVideo;
   Window(1,1,80,25);
   ClrScr;
   AbsGotoXY(1,25);

 End;


Procedure ShowStatusLine(CWindow:Byte;  Other:String);
 var
   ToShow:String;
   ByteTA:Byte;
   I:Integer;
   ha, ma, sa, sa100 : Word;
   TmpLine:String;
   A:String;
 begin
{           1         2         3         4         5         6         7     }
{  12345678901234567890123456789012345678901234567890123456789012345678901234567890 }
{  [#] HH:MM Alias (+i) on #fan        (+nt) [Mail: 18].................00x00 InsC\ }
                                                       {      Mem:100000b 00x00$IC  }
   GetTime(ha, ma, sa, sa100);
{   If (MenuBarLU=sa) and (Length(Other)=0) then exit; }
   If (CWindow=0) then exit;
   MenuBarLU:=sa;
   MenuBar_sa:=sa;  MenuBar_sa100:=sa100;
   TmpX:=AbsWHEREX; TmpY:=AbsWHEREY;

 StatLine[1]:='[';  StatLine[3]:=']';
 ToShow:=LeadingZero(CWindow,2);  Move(ToShow[2], StatLine[2],1);  {NOTE:1 Digit!}

 StatLine[7]:=':';

 If TrumpetBusy then
   begin
     StatLine[1]:='{';  StatLine[3]:='}';
     StatLine[7]:=':';
   end;
 If DebugLogFlag then StatLine[4]:='^' else StatLine[4]:=' ';

 If IRCS.Openned then StatLine[77]:='$'  else  StatLine[77]:=' ';

 ToShow:=LeadingZero(ha,2);     Move(ToShow[1], StatLine[5],2);
 ToShow:=LeadingZero(ma,2);     Move(ToShow[1], StatLine[8],2);
{ ToShow:=LeadingZero(sa,2);     Move(ToShow[1], StatLine[11],2); }

If CW=CWindow then
  begin
   If Spinner> 3 then Spinner:=0;
   Inc(Spinner);
   case Spinner of
     1: begin
         StatLine[80]:='\';
        end;
     2: begin
         StatLine[80]:='-';
        end;
     3: begin
         StatLine[80]:='/';
        end;
     4: begin
         StatLine[80]:='|';
        end;
     5: begin
         StatLine[80]:='*';
        end;
     6: begin
         StatLine[80]:='*';
         Spinner:=0;
        end;
   end;
  end;
If CW<>CWindow then StatLine[80]:=' ';

CCH:=WindowA^[CWindow].CCH;
TmpLine:=User.Nick;
A:='';
 If User.i then A:=A+'i';
 If User.s then A:=A+'s';
 If User.w then A:=A+'w';
 If User.r then A:=A+'r';
 If User.o then A:=A+'O';
 If (CCH<>0) and (CHA^[CCH].Name<>'') then
      begin
        If CHA^[CCH].o then A:=A+'o';
        If CHA^[CCH].v then A:=A+'v';
      end;
 If User.WeAway then A:=A+'G';
 If User.IRCop then A:=A+'*';

If A<>'' then TmpLine:=TmpLine+' (+'+A+')';

If CCH<>0 then
     begin
       TmpLine:=TmpLine+' on '+CHA^[CCH].Name;          { Copy(CHA^[CCH].Name,1,12);}
       If CHA^[CCH].p or CHA^[CCH].s or CHA^[CCH].i or CHA^[CCH].t or CHA^[CCH].n or
          CHA^[CCH].m or (CHA^[CCH].UserLimit>0) or (CHA^[CCH].Key<>'') then
         BEGIN
           TmpLine:=TmpLine+' (+';
           If CHA^[CCH].p then TmpLine:=TmpLine+'p';
           If CHA^[CCH].s then TmpLine:=TmpLine+'s';
           If CHA^[CCH].i then TmpLine:=TmpLine+'i';
           If CHA^[CCH].t then TmpLine:=TmpLine+'t';
           If CHA^[CCH].n then TmpLine:=TmpLine+'n';
           If CHA^[CCH].m then TmpLine:=TmpLine+'m';
           If CHA^[CCH].UserLimit>0 then
               begin
                 Str(CHA^[CCH].UserLimit,ToShow);
                 TmpLine:=TmpLine+'l('+ToShow+')';
              end;
           If CHA^[CCH].Key<>'' then TmpLine:=TmpLine+'k '+CHA^[CCH].Key;
           TmpLine:=TmpLine+')';
       END;
     end;

If DoChkMail then
 begin
  Str(NumMailMsgs, ToShow);
  TmpLine:=TmpLine+' [Mail: '+ToShow+']';
 end;

While Length(TmpLine)<60 do  TmpLine:=TmpLine+' ';
If Length(TmpLine)>(80-20) then TmpLine:=Copy(TmpLine,1,80-20);
Move(TmpLine[1], StatLine[11], Length(TmpLine));

 Str(MemAvail:6, ToShow);
 Move(ToShow[1], StatLine[64], Length(ToShow));
 ToShow:='Mem:';   Move(ToShow[1], StatLine[60], Length(ToShow));

 ToShow:=LeadingZero(WindowA^[CWindow].CX,2);  Move(ToShow[1], StatLine[72],2);
 ToShow:=LeadingZero(WindowA^[CWindow].CY,2);  Move(ToShow[1], StatLine[75],2);
 StatLine[74]:='x';

If tcp_IsConnected(IRCS) then
  begin
   StatLine[79]:='C';
  end else begin
   StatLine[79]:=' ';
  end;
If (IRCS.Result<>0) and (IRCS.Result<>err_timeout) then StatLine[79]:='E';

 If InsertMode then StatLine[78]:='I'  else StatLine[78]:='O';
{ Move(ToShow[1],StatLine[78],1); }

   If Length(Other)<>0 then FillChar(StatLine[45], SizeOf(StatLine)-45, ' ');
   If (Length(Other)>0) and (Length(Other)<35) then
     begin
        StatLine[44]:='|';   Other:='"'+Other+'"';
        Move(Other[1],StatLine[45], Length(Other));
     end;
 Other:='';

 ByteTA:=TextAttr;
 TextColor(0);  TextBackground(7);
   For I:= 1 to Length(StatLine) do
      PutScrnWord(I, WindowA^[CWindow].SY1, Ord(StatLine[I])+(TextAttr shl 8));
  TextAttr:=ByteTA;

 end;



(***************** Window routines **********************)

TYPE  typWdoSet = ( wdo_NewLine, wdo_KeepColor );
      WdoSet = set of typWdoSet;

var  LastMin,  LastMax : Word;
     LineState, tA, LastY, LastX : Byte;
     LastTextColor, LastBackColor : Byte;
     CurTextColor, CurBackColor : String[2];
     Result, I : Integer;

Procedure ResetLine(CWindow:Byte;  Wdo : WdoSet);
Begin
   LastY:=AbsWhereY;  LastX:=AbsWhereX;
   LastMin:=WindMin;   LastMax:=WindMax;
   Window(1,WindowA^[CWindow].Y1, 80, WindowA^[CWindow].Y2);
   AbsGotoXY(WindowA^[CWindow].CX, WindowA^[CWindow].CY);
   If (AbsWhereX<>1) and (wdo_NewLine in Wdo) then Writeln;
   If not (wdo_KeepColor in Wdo) then
     begin
       AttrB_ON:=false;  AttrV_ON:=False;   Attr__ON:=False;
       NormVideo;
       LineState:=0;  LastTextColor:=7;  LastBackColor:=0;
     end else begin
       TextAttr := WindowA^[CWindow].tA;
       TextAttr := 0007;
     end;
End;

Procedure ReturnFromLine(CWindow: Byte;  Wdo : WdoSet);
Begin
  If not (wdo_KeepColor in Wdo) then WindowA^[CWindow].tA := TextAttr;
  NormVideo;
  ClrEol;    {may not need this}

  WindowA^[CWindow].CX:=AbsWhereX;
  WindowA^[CWindow].CY:=AbsWhereY;
  WindMin:=LastMin;   WindMax:=LastMax;
  AbsGotoXY(LastX, LastY);
End;

Procedure WChrWrite(CWindow:Byte; TheChr : Char);
Begin
   Case LineState of
     1 : Begin
           LineState:=0;
(********************
              If ToWrite[I] in ['0'..'9'] then
                   Begin
                     CurTextColor:=CurTextColor+ToWrite[I];
                   End;
              If (Length(ToWrite)>I) then
                   Begin
                     If (not (ToWrite[I+1]) in ['0'..'9')) then
                         begin
                           If (Length(CurTextColor)>0) then
                               begin
                                 Val(CurTextColor, LastTextColor, Result);
                                 TextColor(LastTextColor);
                               end;
                         end;
                   End else
                     LineState:=0;

              If (Length(CurTextColor)>1) and then LineState
              If (ToWrite[I]=',') or (Length(CurTextColor)>1) then LineState:=2;
***********************)
         End;
     Else
         If TheChr in SpecialChr then
             begin
               Case TheChr of
                 #4..#6, #8,
                 #10..#14,
                 #16..#21 : Begin
                                        tA:=TextAttr;
                                        TextColor(0);  TextBackground(7);
                                        Write( Chr(Ord(TheChr)+64) );
                                        TextAttr := tA;
                                     End;
                               ^I  : Write('     ');
                               ^G  : Begin
                                      Sound(770);
                                      DelayMS(70);
                                      NoSound;
                                     End;
                               ^B  : Begin
                                      AttrB_ON := not AttrB_ON;
                                      If AttrB_ON then HighVideo  else LowVideo;
                                     End;
                               ^C  : Begin
                                      CurTextColor := '';  CurBackColor :='';
                                      LineState := 1;
                                     End;
                               ^V  : Begin
                                      AttrV_ON := not AttrV_ON;
                                      If AttrV_ON then
                                          begin
                                           TextColor(0);
                                           TextBackground(7);
                                           If Attr__ON then TextBackground(7); { 1 on color display?}
                                           If AttrB_ON then HighVideo  else LowVideo;
                                          end else begin
                                           TextColor(7);
                                           TextBackGround(0);
                                           If Attr__ON then TextColor(1);
                                           If AttrB_ON then HighVideo  else LowVideo;
                                          end;
                                     End;
                               ^_  : Begin
                                      Attr__ON := not Attr__ON;
                                      If Attr__ON then
                                        begin
                                          TextColor(1);
                                          If AttrV_ON then
                                             begin
                                               TextBackGround(7);
                                               TextColor(0);
                                             end;
                                          If AttrB_ON then HighVideo  else LowVideo;
                                        end else begin
                                          TextColor(7);
                                          If AttrV_ON then
                                            begin
                                             TextBackGround(7);
                                             TextColor(0);
                                            end;
                                          If AttrB_ON then HighVideo  else LowVideo;
                                        end;
                                     End;
                               ^O  : NormVideo;
                               ^A  : Write(^A);
               End;  {case TheChr}
             end; {if TheChr in SpecialChr}
         If not (TheChr in SpecialChr) then Write(TheChr);
    End; {case LineState}
End;

Procedure WWrite(CWindow:Byte; ToWrite:String);
 Begin
   ResetLine( CWindow, [ wdo_KeepColor ] );
   For I:=1 to Length(ToWrite) do  WChrWrite( CWindow, ToWrite[I]);
   ReturnFromLine( CWindow, [ wdo_KeepColor ] );
 End;

Procedure WlnWrite(CWindow:Byte; ToWrite:String);
 Begin
  ResetLine( CWindow, [ wdo_NewLine ] );
  For I:=1 to Length(ToWrite) do  WChrWrite( CWindow, ToWrite[I]);
  ReturnFromLine( CWindow, [ wdo_KeepColor ] );
 End;

Procedure WAWrite(CWindow:Byte; CB:BufferRec);
 Begin
  ResetLine( CWindow, [ wdo_KeepColor ] );
  For I:=1 to CB.Length do  WChrWrite(CWindow, CB.Buffer[I]);
  ReturnFromLine( CWindow, [ wdo_KeepColor ] );
 End;

Procedure WlnAWrite(CWindow:Byte; CB:BufferRec);
 Begin
  ResetLine( CWindow, [ wdo_NewLine ] );
  For I:=1 to CB.Length do  WChrWrite(CWindow, CB.Buffer[I]);
  ReturnFromLine( CWindow, [ wdo_KeepColor ] );
 End;

var  SaveExitProc:Pointer;

{$F+}
Procedure WIN_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   Dispose(WindowA);
 end;

BEGIN
 New(WindowA);
 FillChar(WindowA^, Sizeof(WindowA^), #0);
 SaveExitProc:=ExitProc;
 ExitProc:=@WIN_NewExitProc;
 InitDisplay;
 NumMailMsgs := 0;
 NewMail := 0;
 DoChkMail := False;
 ShowStatusLine(CW,'Initializing...');

END.

