{$DEFINE HBDEBUG}
{$UNDEF  USEMD5}

Unit JPIRC_HB;      {HeartBeat For jpIRC}

Interface

Uses DOS, ABI, ABI_DOM, ABI_JP, JP_UNIT, JPIRCWIN, TPTIMER, INI_MGR, JPIRCVAR, CRT;

TYPE  NotifyEntryPTR = ^NotifyEntryREC;
      NotifyEntryREC = RECORD
                   next : NotifyEntryPTR;
                   options : Byte;
                   who : String[9];
                 END;

Type  tSmallStr = String[40];
      tTinyStr  = String[16];

var  FirstNotify: NotifyEntryPTR;
     CMS : ^tcpSessionREC;    { Check Mail Socket }
     ForceHB : Boolean;
     RunningHB : Boolean;
     BeepNewMail : Boolean;
     LastTimerRun : LongInt;
     NowLong: LongInt;
     HBSecs : Real;
     HBCount : LongInt;
     Pop3Server : ^tSmallStr;       { If Pop3Server^ = '' then its dead }
     Pop3User   : ^tTinyStr;
     Pop3Pass   : ^tTinyStr;
     Pop3IPAddr : IPAddr;

Procedure JPIRC_HeartBeat;
Procedure HBStatReport;

Procedure DoListNotify(Opt:Byte);
Function DoInsNotify(who : String;  options:Byte):Boolean;  {True=OK}
Function DoDelNotify(who : String): Boolean;               {True=OK}


Implementation


CONST INIFileName = 'JPTCP.INI';

var  CurrentNotify: NotifyEntryPTR;
     NewNotify: NotifyEntryPTR;
     TmpStr:String;
     Result:Integer;
     PopChkState : Word;
     PopChkBuffer: ^BufferREC;
     Pop3APop   : ^tSmallStr;
     TmpTextFile: Text;
     Pop3Port   : Word;
     LastNumMsgs  : LongInt;
     LastSizeMsgs : LongInt;
{$IFDEF HBDEBUG}
     HBDebugLog : Text;
{$ENDIF}
     Retries    : Word;

Procedure ProcessChkMail;
var  A,B:String;
     TmpIP:IPAddr;
Begin
   If (Pop3Server^ = '') and (PopChkState<>911) then
     begin
       PopChkState := 0;
       exit;
     end;
   If IsScrLock then WlnWrite(CW, LeadingZero(PopChkState,2));
   If CMS^.Openned then Result:=Tcp_Status(CMS^,0);
   Case PopChkState of
     0 : Begin
           If IPCompare(Pop3IPAddr, NullAddr) or (Pop3Server^='') then
               begin
                 WlnWrite(CW, 'Unable to resolve Pop3 Server '+Pop3Server^);
                 Pop3Server^ := '';
                 exit;
               end;
{           WlnWrite(CW, 'DDD Connecting to Pop3 Server to check # of mail msgs'); }
           PopChkBuffer^.Length := 0;
           Result := tcp_open(CMS^, 0, Pop3IPAddr, 0, Pop3Port, 260);
           If Result<>no_error then
             begin
               WlnWrite(CW, 'Unable to open TCP connection to '+Pop3Server^);
               Pop3Server^ := '';
               exit;
             end;
           PopChkState :=1;
         End;
     1 : Begin   {Get a line}
           DoShowTcpError := False;
           If not tcp_IsConnected(CMS^) then
             begin
{$IFDEF HBDEBUG}
               Writeln(HBDebugLog, 'Was disconnected while waiting to login');
{$ENDIF}
               PopChkState := 911;
               Dec(Retries);
               If Retries < 1 then Pop3Server^ := '';
               exit;
             end;
           If ReadlnBuff(CMS^, PopChkBuffer^) then PopChkState := 2;
           DoShowTcpError := True;
                { Wait for response, and send first login cmd }
                { Wait for response of first cmd and send send login cmd}
         End;
     2 : Begin { Send USER if OK }
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'RESP Received the following:');
           For Result:=1 to PopChkBuffer^.Length do Write(HBDebugLog, PopChkBuffer^.Buffer[Result]);
           Writeln(HBDebugLog, '');
{$ENDIF}
           A:=ShowBuffer(PopChkBuffer^, 4);
           If (Pos('<',A)>0) and ( Pos('>',A) > Pos('<',A) ) then
                                       B:=Copy(A, Pos('<',A), Pos('>',A));
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'Shared Public: '+#34+B+#34);
{$ENDIF}
           If A = '' then PopChkState := 1;
           If Copy(A, 1, 3)='+OK' then
             begin
{$IFDEF USEMD5}
{               If CPURes>2 then
                 Begin
                    TmpStr:=Pop3User^;
                    tcp_sendtextln(CMS^, 'APOP '+TmpStr);
                 End Else Begin                              }

                    Assign(TmpTextFile, 'POP3APOP.1');
                    ReWrite(TmpTextFile);
                    TmpStr:=B + Pop3Pass^ +#26;
                    Write(TmpTextFile,TmpStr);
                    Close(TmpTextFile);
                    SwapVectors;
                     TmpStr:=GetEnv('PGPPATH');
                     If TmpStr='' then Writeln('PGPPATH not defined!');
                     If TmpStr[Length(TmpStr)]<>'\' then TmpStr:=TmpStr+'\';
                     TmpStr:=TmpStr+'MD5SUM.EXE  <POP3APOP.1  >POP3APOP.2';
                     Exec(GetEnv('COMSPEC'), '/C '+TmpStr);
                    SwapVectors;

{                    ReWrite(TmpTextFile); } {Overwrite data}
{                    Writeln(TmpTextFile, '***********************************************'); }
{                    Writeln(TmpTextFile, '********************************'); }
{                    Close(TmpTextFile); }
{                    Erase(TmpTextFile); }

                    Assign(TmpTextFile, 'POP3APOP.2');
                    Reset(TmpTextFile);
                    Readln(TmpTextFile, A);
                    WlnWrite(CW, 'File Line 1 = "'+A+'"');
                    Close(TmpTextFile);
{                    Erase(TmpTextFile); }

                   Pop3APop^:=A;

                   TmpStr:='';
                   TmpStr:=Pop3User^+' '+Pop3APop^;
                   tcp_sendtextln(CMS^, 'APOP '+TmpStr);

{**********}  Writeln( HBDebugLog , 'Sent: "'+TmpStr+'"');

{                 End;                                       }
               PopChkState := 5;
{$ELSE}
               tcp_sendtextln(CMS^, 'USER '+Pop3User^);
               PopChkState := 3;
{$ENDIF}
             end else begin
               PopChkState := 911;
               Pop3Server^ := '';
             end;
         End;
     3 : Begin { Receive response from USER }
           DoShowTcpError := False;
           If not tcp_IsConnected(CMS^) then
             begin
{$IFDEF HBDEBUG}
               Writeln(HBDebugLog, 'Was disconnected while waiting to login');
{$ENDIF}
               PopChkState := 911;
               Dec(Retries);
               If Retries < 1 then Pop3Server^ := '';
               exit;
             end;
           If ReadlnBuff(CMS^, PopChkBuffer^) then PopChkState := 4;
           DoShowTcpError := True;
         End;
     4 : Begin { Send PASS if USER OK }
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'USERRESP Received the following:');
           For Result:=1 to PopChkBuffer^.Length do Write(HBDebugLog, PopChkBuffer^.Buffer[Result]);
           Writeln(HBDebugLog, '');
{$ENDIF}
           A:=ShowBuffer(PopChkBuffer^, 4);
           If Copy(A, 1, 3)='+OK' then
             begin
               tcp_sendtextln(CMS^, 'PASS '+Pop3Pass^);
               PopChkState := 5;
             end else begin
               PopChkState := 911;
               Pop3Server^ := '';
             end;
         End;
     5 : Begin { Receive Response from PASS }
           DoShowTcpError := False;
           If not tcp_IsConnected(CMS^) then
             begin
{$IFDEF HBDEBUG}
               Writeln(HBDebugLog, 'Was disconnected while waiting to login');
{$ENDIF}
               PopChkState := 911;
               Dec(Retries);
               If Retries < 1 then Pop3Server^ := '';
               exit;
             end;
           If ReadlnBuff(CMS^, PopChkBuffer^) then PopChkState := 6;
           DoShowTcpError := True;
         End;
     6 : Begin { Send STAT if PASS OK }
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'PASSRESP Received the following:');
           For Result:=1 to PopChkBuffer^.Length do Write(HBDebugLog, PopChkBuffer^.Buffer[Result]);
           Writeln(HBDebugLog, '');
{$ENDIF}
           A:=ShowBuffer(PopChkBuffer^, 4);
           If Copy(A, 1, 3)='+OK' then
             begin
               tcp_sendtextln(CMS^, 'STAT');
               PopChkState := 7;
             end else begin
               PopChkState := 911;
               Pop3Server^ := '';
             end;
         End;
     7 : Begin { Receive info from STAT }
           DoShowTcpError := False;
           If not tcp_IsConnected(CMS^) then
             begin
{$IFDEF HBDEBUG}
               Writeln(HBDebugLog, 'Was disconnected while waiting to login');
{$ENDIF}
               PopChkState := 911;
               Dec(Retries);
               If Retries < 1 then Pop3Server^ := '';
               exit;
             end;
           If ReadlnBuff(CMS^, PopChkBuffer^) then PopChkState := 8;
           DoShowTcpError := True;
         End;
     8 : Begin { Goto QUIT if received STAT OK }
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'STATRESP Received the following:');
           For Result:=1 to PopChkBuffer^.Length do Write(HBDebugLog, PopChkBuffer^.Buffer[Result]);
           Writeln(HBDebugLog, '');
{$ENDIF}
           A:=ShowBuffer(PopChkBuffer^, 4);
           If Copy(A, 1, 3)='+OK' then
             begin
               B:=PARSERFN(A, 2);
               Val(B, NumMailMsgs, Result);
               If Result<>0 then NumMailMsgs := 0;
               B:=PARSERFN(A, 3);
               Val(B, LastSizeMsgs, Result);
               If Result<>0 then LastSizeMsgs := 0;
               If LastNumMsgs < NumMailMsgs then
                 begin
                  If BeepNewMail then
                    begin
                      Sound(5000);
                      DelayMS(165);
                      NoSound;
                    end;
                  NewMail := NumMailMsgs - LastNumMsgs;
                 end;
               LastNumMsgs := NumMailMsgs;
               PopChkState := 13;
             end else begin
               PopChkState := 911;
               Pop3Server^ := '';
             end;
         End;
    13 : Begin {Send QUIT}
           tcp_sendtextln(CMS^, 'QUIT');
           PopChkState := 14;
         End;
    14 : Begin { Receive info from QUIT }
           DoShowTcpError := False;
           If not tcp_IsConnected(CMS^) then
             begin
{$IFDEF HBDEBUG}
               Writeln(HBDebugLog, 'Was disconnected while waiting to logout');
{$ENDIF}
               PopChkState := 911;
               Dec(Retries);
               If Retries < 1 then Pop3Server^ := '';
               exit;
             end;
           If ReadlnBuff(CMS^, PopChkBuffer^) then PopChkState := 911;
           DoShowTcpError := True;
         End;
   911 : Begin
{$IFDEF HBDEBUG}
           Writeln(HBDebugLog, 'Closing connection with POP3 server');
{$ENDIF}
           If CMS^.Openned then Result:=tcp_Close(CMS^, 0, 150);
           CMS^.Buffer.Length :=0;
           PopChkBuffer^.Length := 0;
           PopChkState := 0;
          End;
   End;

End;


Procedure JPIRC_HeartBeat;
var  InLong: LongInt;
     OutLong: LongInt;
     TmpReal: Real;
Begin
 InLong:=0;
 Inc(OutLong);
 NowLong:=ReadTimer;
 If HBSecs=0 then exit;
 If PopChkState>0 then ProcessChkMail;
 If PopChkState>0 then MailOther := '.' else Mailother :=' ';

 If (ElapsedTime(LastTimerRun, NowLong)/1000 > HBSecs) or ForceHB then
  begin
{    WlnWrite(CW, '$$$ HeartBeat has been processed '+ElapsedTimeString(LastTimerRun, NowLong)); }
    Inc(HBCount);

    If (PopChkState = 0) and DoChkMail then ProcessChkMail;
    LastTimerRun := ReadTimer;
    ForceHB := False;
    Inc(OutLong);
  end;
End;

Procedure HBStatReport;
var  TmpReal : Real;
Begin
 Str(HBCount, TmpStr);
 WlnWrite(CW, '# of Heartbeats since startup = '+TmpStr);
 TmpReal := HBSecs * 1000;
 Str(TmpReal:0:3, TmpStr);
 WlnWrite(CW, '      Time Between heartbeats = '+TmpStr);
 WlnWrite(CW, '      Time Elapsed Since last = '+ElapsedTimeString(LastTimerRun, NowLong));

 WlnWrite(CW, '  Pop3 Server = '+Pop3Server^);
 WlnWrite(CW, '  Pop3 IPAddr = '+IPTOASCII(Pop3IPAddr));
 Str(Pop3Port, Tmpstr);
 WlnWrite(CW, '  Pop3 Port   = '+TmpStr);
 WlnWrite(CW, '  Pop3 User   = '+Pop3User^);
 WlnWrite(CW, '  Pop3 Pass   = '+Pop3Pass^);
 Str(LastNumMsgs, TmpStr);
 WlnWrite(CW, '  Last total number of mail messages   : '+TmpStr);
 Str(NumMailMsgs, TmpStr);
 WlnWrite(CW, '  Current Total Number of mail messages: '+TmpStr);
 Str(NewMail, TmpStr);
 WlnWrite(CW, '  Number of NEW messages since last heartbeat: '+TmpStr);
End;


{True on Error}
Function zNotifyRetreive(var TheFirst:Boolean):Boolean;
Begin
  zNotifyRetreive := False;
  If TheFirst then
    begin
     CurrentNotify := FirstNotify;
     If FirstNotify = nil then zNotifyRetreive := True;
     TheFirst := False;
     exit;
    end;
  If (CurrentNotify = nil) or (CurrentNotify^.next = nil) then
    begin
      zNotifyRetreive := True;
      exit;
    end;
  CurrentNotify := CurrentNotify^.next;
End;

Function RetreiveNotify(who:String):NotifyEntryPTR;
var TmpB : Boolean;
Begin
 RetreiveNotify := nil;
 If who='' then
   begin
    exit;
   end;
 TmpB:=True;

 while not zNotifyRetreive(TmpB) do
   begin
     If uCase(who)=uCase(CurrentNotify^.who) then
       begin
         RetreiveNotify := CurrentNotify;
         break
       end;
   end;
End;

Procedure DoListNotify(Opt:Byte);
var TmpB:Boolean;
Begin
 TmpB:=True;
 Str(CurrentNotify^.options:3, TmpStr);
 WlnWrite(CW, 'Options    Username   ');
 while not zNotifyRetreive(TmpB) do
   begin
     WlnWrite(CW, TmpStr+'     "'+CurrentNotify^.who+'"');
   end;
End;

{True on OK}
Function DoInsNotify(who:String;  options:Byte):Boolean;  {True=OK}
var TmpB:Boolean;
Begin
 DoInsNotify:=False;
 TmpB:=True;
 while not zNotifyRetreive(TmpB) do
   begin
     If UCase(CurrentNotify^.who) = UCase(who) then
           begin
             WlnWrite(CW, 'User '+who+' already has a key set');
             exit;
           end;
   end;
 If MemAvail < (SizeOf(NotifyEntryREC)*2)+1024 then
   begin
     WlnWrite(CW, 'Insufficient Memory to add notify for '+who);
     exit;
   end;

 New(NewNotify);
 NewNotify^.who := who;
 NewNotify^.options := options;
 NewNotify^.next := nil;

 if FirstNotify = nil then FirstNotify := NewNotify
                   else CurrentNotify^.next := NewNotify;
 CurrentNotify := NewNotify;
 DoInsNotify := True;
End;


{TRUE on OK}
Function DoDelNotify(who : String): Boolean;
var TmpB: Boolean;
    LastNotify : NotifyEntryPTR;
Begin
   DoDelNotify := False;
{   If who='!' then all }
   CurrentNotify:=FirstNotify;
   If UCase(FirstNotify^.who) = UCase(who) then
        begin
          FirstNotify := FirstNotify^.next;
          Dispose(CurrentNotify);
          CurrentNotify:=FirstNotify;
          DoDelNotify:= True;
          exit;
        end;

   LastNotify := FirstNotify;
   repeat
     If UCase(CurrentNotify^.who)=UCase(who) then
         begin
          LastNotify^.next := CurrentNotify^.next;
          Dispose(CurrentNotify);
          CurrentNotify := FirstNotify;
          DoDelNotify:=True;
          break;
         end;
     LastNotify := CurrentNotify;
     CurrentNotify := CurrentNotify^.next;
   until CurrentNotify = nil;
   CurrentNotify := FirstNotify;
End;

Procedure InitializeHB;
var  FAP : FieldType;
     TmpB: Boolean;
Begin
  ForceHB := False;
  RunningHB := False;
  NumMailMsgs := 0;  PopChkState := 0;
  Mailother := ' ';
  BeepNewMail := True;
  LastNumMsgs := 0;    NewMail := 0;

  HBSecs:=180;
  LastTimerRun := ReadTimer;
  Retries := 2;
  FillChar(CMS^, SizeOf(CMS^), #0);
  Pop3Server^ := '';    Pop3User^ := '';
  Pop3APop^ := '';      Pop3Pass^ := '';

  FAP.Field:='HBSecs';   FAP.Value:='OFF';
  LoadINISection(INIFileName, 'JPIRC', 1, @FAP);
  If FAP.Value<>'' then
    begin
      Val(FAP.Value, HBSecs, Result);
      If Result<>0 then HBSecs:=180;
      If uCase(FAP.Value)='OFF' then HBSecs := 0;
    end;

  FAP.Field := 'Server';   FAP.Value:='';
  LoadINISection(INIFileName, 'POP3', 1, @FAP);
  If FAP.Value<>'' then
    begin
      Pop3Server^ := FAP.Value;
      If not ip_lookup(Pop3Server^, Pop3IPAddr) then
          begin
 {           WlnWrite(CW, 'Unable to resolve Pop3 Server '+Pop3Server^);   }
            Pop3Server^ := '';
          end;
    end;

   FAP.Field:='Port';   FAP.Value:='110';
   LoadINISection(INIFileName, 'POP3', 1, @FAP);
   If FAP.Value<>'' then
     begin
       Val(FAP.Value, Pop3Port, Result);
       If Result<>0 then Pop3Port:=110;
       If Pop3Port=0 then Pop3Server^ := '';
     end;

  FAP.Field := 'BeepNewMail';   FAP.Value:='True';
  LoadINISection(INIFileName, 'POP3', 1, @FAP);
  If FAP.Value<>'' then BeepNewMail:=WasTrueFalse(FAP.Value);

  FAP.Field := 'User';   FAP.Value:='';
  LoadINISection(INIFileName, 'POP3', 1, @FAP);
  If FAP.Value<>'' then Pop3User^ := FAP.Value;

  FAP.Field := 'Password';   FAP.Value:='';
  LoadINISection(INIFileName, 'POP3', 1, @FAP);
  If FAP.Value<>'' then Pop3Pass^ := FAP.Value;

  If (Pop3User^='') or (Pop3Pass^='') then Pop3Server^ := '';

End;

var  SaveExitProc:Pointer;
{$F+}
Procedure HB_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
{$IFDEF HBDEBUG}
   Close(HBDebugLog);
{$ENDIF}
   Dispose(Pop3APop);
   Dispose(Pop3Pass);
   Dispose(Pop3User);
   Dispose(Pop3Server);
   If CMS^.Openned then Result:=tcp_Close(CMS^, 0, 100);
   Dispose(CMS);
   Dispose(PopChkBuffer);

 end;

BEGIN
 FirstNotify := nil;  CurrentNotify := nil;  NewNotify := nil;
 New(CMS);
 New(PopChkBuffer);
 New(Pop3Server);
 New(Pop3User);
 New(Pop3Pass);
 New(Pop3APop);
 SaveExitProc:=ExitProc;
 ExitProc:=@HB_NewExitProc;
{$IFDEF HBDEBUG}
 Assign(HBDebugLog, 'HBDEBUG.LOG');
 ReWrite(HBDebugLog);
{$ENDIF}
 HBCount := 0;
 RunningHB := False;
 InitializeHB;
END.

