Unit JPIRC_IO;

{$UNDEF NEW}

Interface

Uses DOS,CRT,ABI,JP_UNIT,MkScrn,JPIRCWIN,JPIRCVAR;

CONST MaxHistory = 20;
      EOS = 80; {End of Screen}

type  pHistory = Array[0..MaxHistory] of String[255];

var
	CCmd			: String;
	CCmdValid : Boolean;
  History   : ^pHistory;
  LastKey   : String[255];
	DoExit		: Boolean;
	ConsoleX	: Byte;
	ConsoleY	: Byte;

Procedure ProcessConsoleIO;

Implementation


Var SaveExitProc : Pointer;
    QuoteNextChar : Boolean;
    CurrentHistory:Byte;

{$IFDEF NEW}

var Len, Sze, Ps : Byte;

Procedure ProcessConsoleIO;
var  S:String;
     ch, chExt : Char;
     Key : String[80];
     LastMin, LastMax : Word;
     LastX, LastY:Byte;
     tA : Byte;
     tW, W : Word;

 procedure MoveLeft(Amount:Byte);
  begin
     If Amount > ConsoleX-1 then Amount := ConsoleX-1;
     ConsoleX := ConsoleX - Amount;
  end;
 procedure MoveRight(Amount:Byte);
  begin
     If Amount+ConsoleX > EOS then Amount := 80-ConsoleX;
     ConsoleX := ConsoleX + Amount;
  end;

 procedure UpdateString(Add : Boolean);
 begin
    Write(Copy(CCmd,Ps,255));
    if Add then
    begin
       Write(' ');
       MoveLeft(Sze-Ps+1);
    end else MoveLeft(Sze-Ps);
 end;

 procedure AddChar(C : Char);
 begin
(*****
    if (Ps >= Len) or (Sze >= Len) or ((Ps = 1) and (C = ' ') and
      (not space) ) then Exit;
*****)
    If (Ps >= Len) or (Sze >= Len) then exit;

    { ProcessChar }

     If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
              Begin
                tA:=TextAttr;
                TextColor(0);  TextBackground(7);
                Key[1]:=Chr( Ord(Key[1])+64 );
              End;
{                           InsCharInLine(ConsoleX, 25, Key[1]); }
    Write(C);
      If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
               Begin
                 TextAttr:=tA;
               End;


    if Ps = Sze then
    begin
       CCmd := CCmd + C;
       Inc(Sze,1);
       Inc(Ps,1);
    end else if InsertMode then
    begin
       Insert(C,CCmd,Ps);
       Inc(Sze,1);
       Inc(Ps,1);
       UpdateString(False);
    end else
    begin
       CCmd[Ps] := C;
       Inc(Ps,1);
       UpdateString(False);
    end;
 end;

 procedure Backspace;
 begin
    if Ps <= 1 then Exit;
    Write(#8+' '+#8);
    Dec(Ps,1);
    Dec(Sze,1);
    Delete(CCmd,Ps,1);
    if Ps < Sze then UpdateString(True);
 end;

 procedure DelChar;
 begin
    if (Sze < 2) or (Ps >= Sze) then Exit;
    Delete(CCmd,Ps,1);
    Write(Copy(CCmd,Ps,255)+' ');
    MoveLeft(Sze-Ps);
    Dec(Sze,1);
 end;

 procedure NextWord;
 var N, Z : Byte;
 begin
    if Ps = Sze then Exit;
    Z := 0;
    for N := Ps+1 to Sze do if (Z = 0) and (CCmd[N] in [' ','-']) then Z := N;
    if Z = 0 then Z := Sze;
    if Ps = Z then Exit;
    MoveRight(-Ps+Z);
    Ps := Z;
 end;

 procedure LastWord;
 var N, Z : Byte;
 begin
    if (Ps = 1) or (Sze < 2) then Exit;
    Z := 0;
    for N := Ps-1 downto 1 do if (Z = 0) and (CCmd[N] in [' ','-']) then Z := N;
    if Z = 0 then Z := 1;
    if Ps = Z then Exit;
    if Z > Ps then MoveRight(Z-Ps) else MoveLeft(Ps-Z);
    Ps := Z;
 end;

 procedure ClearEol;
 var Z : Byte;
 begin
    if (Ps = Sze) then Exit;
    for Z := Ps to Sze do Write(' ');
    MoveLeft(Sze-Ps+1);
    Delete(CCmd,Ps,255);
    Sze := Ps;
 end;

 procedure ClearItAll;
 var Z : Byte;
 begin
    if (Sze = 1) then Exit;
    MoveLeft((Ps-1));
    for Z := 1 to Sze do Write(' ');
    MoveLeft(Sze);
    Delete(CCmd,1,255);
    Sze := 1;
    Ps := 1;
 end;

 procedure DoTab;
 var Z : Byte;
 begin
    for Z := 1 to 4 do AddChar(' ');
 end;

Function mXPos:Byte;
CONST    XConMOD = 10;
var      tX : Byte;
Begin
  mXPos := ConsoleX;
  If ConsoleX < EOS then exit;

  tX:= ConsoleX MOD XConMOD;
  If ConsoleX > XConMOD then Inc(tX);
  If tX=0 then Inc(tX);
  tX := CONSOLEX;
  mXPos := tX;

  mXPos := Sze;
End;


Begin    (************** ProcessConsoleIO ***************)
   If CCmdValid then
     Begin
       If (History^[0]<>CCmd) then
         Begin
           For W:=25 downto 1 do  History^[W] := History^[W-1];
           History^[0]:=CCmd;
         End;
       CCmd := '';
       ConsoleX := 1;  ConsoleY :=1;
       Sze := 1;  Ps := 1;
       AbsGotoXY(Sze, 25);  ClrEol;
       CurrentHistory :=0;
     End;
   CCmdValid := False;
   Len := 255;   { ? 256 because it is Inc()'d below? }
{   Inc(Len,1); }

   Key := Inkey;
   If Length(Key)=0 then
     begin
       LastKey := Key;
       exit;
     end;
   LastMin := WindMin;   LastMax := WindMax;

   If ConsoleX=0 then ConsoleX :=1;
   If ConsoleY=0 then ConsoleY :=1;

   Window(1,25,80,25);
{   AbsGotoXY(mXPos, 25); }
   AbsGotoXY(Ps, 25);

   If (Length(key)=2) and (Key[1]=#0) then
     begin
         case Key[2] of
{alt-x}    #45  : DoExit := True;
{F5}       #63  : Begin
                    W := WindowA^[CW].CCH;
                    tW := W;
                    repeat
                       Inc(W);
                       If W>MaxChannels then W:=1;
                    until (CHA^[W].Name<>'') or (W=tW);
                    WindowA^[CW].CCH := W;
                    If CHA^[W].Name='' then WindowA^[CW].CCH := tW;
                  End;
{F6}       #64  : Begin
                   For W:=CW+1 to MaxWindows do
                     begin
                       If WindowA^[W].Y1<>0 then break;
                     end;
                   If WindowA^[W].Y1=0 then W:=1;
                   CW:=W;
                  End;
{F9}       #67  : DebugLogFlag := not DebugLogFlag;
{Up}       #72  : Begin
                   CCmd:=History^[CurrentHistory];
                   If (CurrentHistory<MaxHistory) and
                      (History^[CurrentHistory+1] <> '') then Inc(CurrentHistory);

                       AbsGotoXY(1,25); ClrEol;
                       Write(CCmd);
                       CONSOLEX := Length(CCmd)+1;
                       AbsGotoXY(Ps,25);
                  End;
{Down}     #80  : Begin
                   CCmd:=History^[CurrentHistory];
                   If (CurrentHistory>0) then Dec(CurrentHistory);
                       AbsGotoXY(1,25); ClrEol;
{                       Write(CCmd); }
                       UpdateString(false);
                       CONSOLEX := Length(CCmd)+1;
                       AbsGotoXY(Ps,25);
                  End;

           #112 : DebugLogFlag := not DebugLogFlag;
{Left}     #75  : if (Ps > 1) then begin Dec(Ps,1); MoveLeft(1); end;
{Right}    #77  : if (Ps < Sze) then begin Inc(Ps,1); MoveRight(1); end;
{Home}     #71  : if (Ps > 1) then begin MoveLeft(Ps-1); Ps := 1; end;
{End}      #79  : if (Ps < Sze) then begin MoveRight(Sze-Ps); Ps := Sze; end;
{Insert}   #82  : InsertMode := not InsertMode;
{Delete}   #83  : DelChar;
{Ctrl <-}  #115 : LastWord;
{Ctrl ->}  #116 : NextWord;
{Ctrl End} #117 : ClearEol;
         end;
     end;

{ AbsGotoXY(mXPos,25); }
 LastKey := Key;
 If Length(Key)=1 then
   BEGIN
      case Key[1] of
{Enter}    #13 : CCmdValid := True;
           #10 : CCmdValid := True;
(******
           #13 : if ((not Min) or (Ps > 1)) and
                    ((not Req) or (Ps = Len)) then CCmdValid := True;
*******)
{Bkspace}  #8  : Backspace;
{Tab}      #9  : DoTab;
           #17 : Begin
                    If QuoteNextChar then
                         begin
                           AddChar(#17);
                           LastKey := #0;
                         end;
                 End;
           #18 : Begin
                     AbsGotoXY(1,25); ClrEol;
                     Write(CCmd);
                     CONSOLEX := Length(CCmd)+1;
                     AbsGotoXY(mXPos,25);
                 End;
{Ctrl Y}   #25 : ClearItAll;
{ESC / ^Z} #27 : begin CCmd := ''; CCmdValid := False {True}; ConsoleX := 0; end;
{Anything} #1..#16,
          #19..#26,
         #28..#254 : AddChar(Key[1]);
      end;
   END;

	WindMin:=LastMin;  WindMax:=LastMax;
  If LastKey<> ^Q then QuoteNextChar := False   else QuoteNextChar:=True;


End;




{$ELSE}        (*********************** THE OLD ONE **********************)

Function mXPos:Byte;
CONST    XConMOD = 10;
var      tX : Byte;
Begin
  mXPos := ConsoleX;
  If ConsoleX < EOS then exit;

  tX:= ConsoleX MOD XConMOD;
  If ConsoleX > XConMOD then Inc(tX);
  If tX=0 then Inc(tX);
  tX := CONSOLEX;
  mXPos := tX;
End;

Procedure ProcessConsoleIO;
var ch	 :Char;
		chExt:Char;
		Key  :String[80];
		LastMin, LastMax:Word;
		LastX, LastY:Byte;
    tA : Byte;
    tW : Word;
    W  : Word;
Begin
	If CCmdValid then
		Begin
      If (History^[0]<>CCmd) then
        Begin
         For W:=25 downto 1 do   History^[W]:=History^[W-1];
         History^[0]:=CCmd;
        End;
			CCmd:='';
			ConsoleX:=1;	ConsoleY:=1;
      AbsGotoXY(mXPos,25);  ClrEol;                           {*MOD*}
      CurrentHistory:=0;
    End;
	CCmdValid:=False;
	Key:=Inkey;
	If Length(Key)=0 then
		Begin
		 LastKey:=Key;
		 exit;
		End;
	LastMin:=WindMin;  LastMax:=WindMax;
{ 	LastX:=AbsWhereX;  LastY:=AbsWhereY;	}
	If (ConsoleX=0) or (ConsoleY=0) then
		Begin
			ConsoleX:=1;
			ConsoleY:=1;											{For Future use instead of using}
																				{one string to hold 255 characters, we}
																				{will use a couple of 80 column strings}
		End;
	Window(1,25,80,25);
  AbsGotoXY(mXPos,25);                                      {*MOD*}
  If (ConsoleX >Length(CCmd)+1) then CCmd[0]:=CHR(ConsoleX-1);  {*MOD*}
	If (Length(Key)=2) and (Key[1]=#0) then
		Begin
		 Case Key[2] of
(*******************
				#19  : Begin
								If not Online then exit;
								tcp_sendtextln(IRCS, 'NICK '+User.Nick);
								If IRCS.Result<>0 then WlnWrite(CW, 'Send Error: ');
								tcp_sendtextln(IRCS, 'USER '+User.UserName+' . . :'+User.RealName);
								If IRCS.Result<>0 then WlnWrite(CW, 'Send Error: ');
							 End;
********************)
				#45  : DoExit:=True;													 {Emergency Exit = Alt-X}
        #63  : Begin { F5 }
                 W:=WindowA^[CW].CCH;
								 tW:=W;
								 repeat
									Inc(W);
									If W>MaxChannels then W:=1;
                 until (CHA^[W].Name<>'') or (W=tW);
                 WindowA^[CW].CCH := W;
                 If CHA^[W].Name='' then WindowA^[CW].CCH := tW;
							 End;
        #64  : Begin { F6 }
								 For W:=CW+1 to MaxWindows do
									 begin
                     If WindowA^[W].Y1<>0 then break;
									 end;
                 If WindowA^[W].Y1=0 then W:=1;
								 CW:=W;
							 End;
        #67   : DebugLogFlag:=not DebugLogFlag;                   { F9 }
        #112  : DebugLogFlag:=not DebugLogFlag;                   { Alt-F9 }
        #72  : Begin   { Up }
                 CCmd:=History^[CurrentHistory];
                 If (CurrentHistory<MaxHistory) and
                    (History^[CurrentHistory+1] <> '') then Inc(CurrentHistory);

                     AbsGotoXY(1,25); ClrEol;
                     Write(CCmd);
                     CONSOLEX := Length(CCmd)+1;
                     AbsGotoXY(mXPos,25);
               End;
        #80  : Begin    { Down }
                 CCmd:=History^[CurrentHistory];
                 If (CurrentHistory>0) then Dec(CurrentHistory);
                     AbsGotoXY(1,25); ClrEol;
                     Write(CCmd);
                     CONSOLEX := Length(CCmd)+1;
                     AbsGotoXY(mXPos,25);
               End;
        #75  : If ConsoleX>1 then Dec(ConsoleX);                      { Left  }
				#77  : If ConsoleX<Length(CCmd)+1 then Inc(ConsoleX); 				{ Right }
				#71  : ConsoleX:=1; 																					{ Home	}
				#79  : ConsoleX:=Length(CCmd)+1;															{ End 	}
        #82  : InsertMode:= false; { not InsertMode; }
				#83  : Begin
								 If Length(CCmd)>0 then Delete(CCmd,ConsoleX,1);
								 DelCharInLine( ConsoleX, 25);
							 End;
			 End;
		End;
AbsGotoXY(mXPos,25);                                         {*MOD*}
	LastKey:=Key;
	If Length(Key)=1 then
		Begin
			Case Key[1] of
				#8			 : Begin
										 If Length(CCmd)>0 then Delete(CCmd,ConsoleX-1,1);
										 Write(#8+' '+#8);
										 Dec(ConsoleX);
									 End;
				#13,#10  : Begin
										 If Length(CCmd)>0 then CCmdValid:=True;
										 ConsoleX:=Length(CCmd)+1;
										 ConsoleY:=1;
									 End;
        #17      : Begin
                     If QuoteNextChar then
                         begin
                           CCmd:=CCmd+#17;
                           LastKey:=#0;
                         end;
                   End;
        #18      : Begin {Control-R}
                     AbsGotoXY(1,25); ClrEol;
                     Write(CCmd);
                     CONSOLEX := Length(CCmd)+1;
                     AbsGotoXY(mXPos,25);
                   End;
        #27      : Begin
                     AbsGotoXY(1,25); ClrEol;
                     CCmd:='';
                     CONSOLEX := 1;
                     AbsGotoXY(mXPos,25);
                   End;
        #0..#16,#19..#26,
        #28..#254: Begin
										 If Length(CCmd)<255 then
											 Begin
												 If InsertMode then
													 begin
														If Length(CCmd)>0 then Insert(Key[1],CCmd,ConsoleX-1)
																							else CCmd:=Key[1];
														If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
																		 Begin
																			 tA:=TextAttr;
                                       TextColor(0);  TextBackground(7);
																			 Key[1]:=Chr( Ord(Key[1])+64 );
																		 End;
														InsCharInLine(ConsoleX, 25, Key[1]);
														If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
																		 Begin
																			 TextAttr:=tA;
																		 End;
														Inc(ConsoleX);
													end else begin
														CCmd[ConsoleX]:=Key[1];
                            AbsGotoXY(mXPos,25);                   {*MOD*}
														If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
																		 Begin
																			 tA:=TextAttr;
                                       TextColor(0);  TextBackground(7);
																			 Key[1]:=Chr( Ord(Key[1])+64 );
																		 End;
														Write(Key[1]);
														If Key[1] in [#0..#7,#9,#11..#12,#14..#26,#28..#31] then
																		 Begin
																			 TextAttr:=tA;
																		 End;
														Inc(ConsoleX);
													end;
											 End Else Begin
												 Sound(1000);
												 DelayMS(115);
												 NoSound;
											 End;
									 End;
					 End;
		End;



	WindMin:=LastMin;  WindMax:=LastMax;
  If LastKey<> ^Q then QuoteNextChar := False   else QuoteNextChar:=True;
{  AbsGotoXY(LastX, LastY); }
  NormVideo;
  AbsGotoXY( { Length(CCmd)+2 } mXPos+1,25);  ClrEol;                     {*MOD*}
  AbsGotoXY(mXPos, 25);                                     {*MOD*}
End;

{$ENDIF} {ELSE IF NEW}

{$F+}
Procedure IO_NewExitProc; far;
 begin
   ExitProc:=SaveExitProc;
   Dispose(History);
 end;

BEGIN
 New(History);
 FillChar(History^, SizeOf(History^), #0);
 CurrentHistory:=0;
 CCmd:='';  CCmdValid:=False;
 DoExit:=False;
 ConsoleX:=1;  ConsoleY:=1;
 InsertMode:=False;
 SaveExitProc:=ExitProc;
 ExitProc:=@IO_NewExitProc;

END.

