Unit _TELNET;

Interface

Uses ABI;

CONST   FrameSize       = 25;
        INIFileName = 'JPTCP.INI';
var  Frame: String[FrameSize];
     TerminalSpeed : String;
     TerminalType : String;
     IACState : Byte;
     IAC      : Boolean;
     SE       : String;
     FIAC     : Boolean;
    Other:String;
    Spinner:Integer;
    DSpinner:Integer;
    MenuBarLU:Word;
    StatLine:String[80];
    LastLine:String[80];
    V : String;
    TrumpetBusy : Boolean;

Function HandleIAC(CS:tcpSessionREC; var C:Char):String;
Procedure ShowStatusBar(Other:String);

Implementation

Uses CRT,DOS,MKAVT102,MKSTRING,MKScrn,JP_UNIT,XSTRING, INI_MGR;


Procedure ShowStatusBar(Other:String);
 var
   ToShow:String;
   LastX:Integer;            { from here}
   LastY:Integer;
   TmpX:Integer;
   TmpY:Integer;
   ByteTA:Byte;
   I:Integer;
   ha, ma, sa, sa100 : Word;
 begin
{   FillChar(StatLine[1],80, #32);}
   GetTime(ha, ma, sa, sa100);
   if MenuBarLU=sa then exit;
   MenuBarLU:=sa;
{   TmpX:=WHEREX; TmpY:=WHEREY; }

{   DriverIO; }

   If Spinner> 3 then Spinner:=0;
   Inc(Spinner);
   case Spinner of
     1: begin
         StatLine[1] :='/';
         StatLine[80]:='\';
        end;
     2: begin
         StatLine[1] :='-';
         StatLine[80]:='-';
        end;
     3: begin
         StatLine[1] :='\';
         StatLine[80]:='/';
        end;
     4: begin
         StatLine[1] :='|';
         StatLine[80]:='|';
         Spinner:=0;
        end;
   end;
   If TrumpetBusy then
     begin
      case Spinner of
        1: StatLine[80]:='.';
        2: StatLine[80]:='o';
        3: StatLine[80]:='O';
        4: StatLine[80]:='*';
       end;
      StatLine[1] := StatLine[80];
     end;

{     If PrintCntrl then StatLine[1]:='P'  else StatLine[1]:='p';}
     If AutoWrap   then StatLine[1]:='W'  else StatLine[1]:='w';
     If ApplicationMode then StatLine[2]:='A'  else StatLine[2]:='a';
     If AvtEcho    then StatLine[3]:='E'  else StatLine[3]:='e';
     If PrintCntrl then StatLine[4]:='C'  else StatLine[4]:='c';
     If AutoPrint  then StatLine[5]:='P'  else StatLine[5]:='p';
     If AutoRepeat then StatLine[6]:='R'  else StatLine[6]:='r';


     If AvtEolCRLF then ToShow:='LF'  else ToShow:='lf';
     Move(ToShow[1],StatLine[8],2);

     ByteTA:=tcp_Status(CurSession,0);
     ToShow:=StrHex(CurSession.Status.State,2);
     Move(ToShow[1], StatLine[11],2);


     If PrintFullScreen then ToShow:='Scr'  else ToShow:='Rgn';
     Move(ToShow[1], StatLine[16],3);

     If PrintScreenFF then ToShow:='FF'  else ToShow:='  ';
     Move(ToShow[1],StatLine[19],2);

     If InsertMode then ToShow:='INS'  else ToShow:='ins';
     Move(ToShow[1],StatLine[22],3);

{   Write(' Time= ',ha:2,':',ma:2,':',sa:2,'.',sa100:2,' '); }

   If IsScrLock then
     begin
        Other:=SE;
     end;

   If (Length(Other)>0) and (Length(Other)<50) then
     begin
        StatLine[29]:='|';   Other:='"'+Other+'"';
        Move(Other[1],StatLine[30], Length(Other));
     end;
   Other:=Long2Str(IACState);
   StatLine[26]:=Other[1];
   StatLine[27]:=Other[2];
   StatLine[28]:=Other[3];
   If IACState<100 then StatLine[28]:=' ';
   If IACState<10 then StatLine[27]:=' ';

     ToShow:=StrHex(PktsInputQueue,4);
     Move(ToShow[1], StatLine[35],4);

     ToShow:=StrHex(PktsOutputQueue,4);
     Move(ToShow[1], StatLine[40],4);

     ToShow:=StrHex(CurSession.Status.BytesGoing,4)+'      ';
     Move(ToShow[1], StatLine[50],5);

  If LastLine<>StatLine then
    Begin
       ByteTA:=TextAttr;
       TextColor(0);  TextBackground(7);
         For I:= 1 to Length(StatLine) do
            PutScrnWord(I, ScrnHeight, Ord(StatLine[I])+(TextAttr shl 8));
        TextAttr:=ByteTA;
    End;

 end;



CONST
        env_IS   = 0;  { sent by client (replies to env_SEND's) }
        env_SEND = 1;  { sent by server }
        env_INFO = 2;  { sent by client (updates) }
        env_VAR     = 0;        env_VALUE   = 1;
        env_ESC     = 2;        env_USERVAR = 3;
var   IACDO_Handlers   : set of #0..#255;   { We receive a "DO"   }
      IACWILL_Handlers : set of #0..#255;   { We receive a "WILL" }
      NumIACReqs : LongInt;
      SubSession: tcpSessionREC;

Procedure Do_IAC_ENVIRON(Data : String);  { SEND request received }
CONST  EnvSpecial : String[5] = #$FF + #$00 + #$01 + #$02 + #$03;

var TmpReply : String;
    TmpVar   : String;
    TmpVal   : String;
    TmpType  : Byte;
    ActiveESC: Boolean;

            Function GetENVIRON(Variable : String):String;
            Begin
               GetENVIRON := '';
               If uCase(Variable)='USER'  then GetENVIRON := 'Tester';
               If uCase(Variable)='ERASE' then GetENVIRON := '^H';
               If (uCase(Variable)='SYSTEMTYPE') or
                  (uCase(Variable)='SYST') then
                   Begin
                     GetENVIRON := 'MS-DOS';
                   End;
            End;
            Procedure NewToSend;
            Begin
             If ActiveEsc then
              Begin
                TmpVar := TmpVar + Data[1];
                Delete(Data,1,1);
                exit;
              End;
               Case Data[1] of
                #$FF: Begin
                       Writeln('[ERROR: Recursive IAC implementation not handled]');
                       Data := '';
                       exit;
                      End;
                 #0 : TmpType := env_VAR;
                 #1 : TmpType := env_VALUE;
                 #2 : Begin
                       Delete(Data,1,1);
                       ActiveEsc := TRUE;
                      End;
                 #3 : TmpType := env_USERVAR;
                END;
            End;

Begin                             { IAC     SB  ENVIRON   IS ... }
 ActiveESC := FALSE;   TmpReply := #$FF + #$FA + #$24 + #$00;
 Data := '';
 If Data = '' then Exit;
 repeat
  NewToSend;
  TmpVar := '';
   While (Pos(Data[1], EnvSpecial)=0) and (Data<>'') and (not IsScrLock) do
     begin
       TmpVar := Data[1];
       Delete(Data,1,1);
     end;

  Case TmpType of
    0 : Begin
          TmpVal := GetENVIRON(TmpVar);
                               { env_VAR }        { env_VALUE }
          TmpReply := TmpReply +   #0    + TmpVar +    #1     + TmpVal;
          Writeln('going to send Variable "'+TmpVar+'" = "'+TmpVal+'"');
        End;
    1 : Writeln('[Received env_IS env_VALUE]');
    2 : Writeln('[Received env_IS env_ESC]');
    3 : Writeln('[Received env_IS env_USERVAR]');
  End;

 until Data='';
 tcp_sendtext(SubSession, TmpReply);
 Result := tcp_Status(SubSession, 0);
   If Result=0 then ShowStatusBar('*ENVIRON_RSENT*')
               else ShowStatusBar('*ENVIRON_NOT_RSENT*');
End;

{IACStates:                            }
{          1 = IAC was received                                 }
{          2 = SB ($FA) received (receives data till SE ($F0)   }
{          3 = WILL  ($FB) received                             }
{          4 = WON'T ($FC) received                             }
{          5 = DO    ($FD)                                      }
{          6 = DON'T ($FE)                                      }
Function HandleIAC(CS:tcpSessionREC; var C:Char):String;
 CONST
        IACC_WILL :String[2] = #$FF+#$FB;   IACC_WONT :String[2] = #$FF+#$FC;
        IACC_DO   :String[2] = #$FF+#$FD;   IACC_DONT :String[2] = #$FF+#$FE;
        IACC_SB   :String[2] = #$FF+#$FA;   IACC_SE   :String[2] = #$FF+#$F0;

        IAC_SE   = $F0;   IAC_NOP  = $F1;   IAC_DM  = $F2;  IAC_BRK  = $F3;
        IAC_IP   = $F4;   IAC_AO   = $F5;   IAC_AYT = $F6;  IAC_EC   = $F7;
        IAC_EL   = $F8;   IAC_GA   = $F9;   IAC_SB  = $FA;

        IAC_IAC  = $FF;
        IAC_WILL = $FB;   IAC_WONT = $FC;   IAC_DO  = $FD;  IAC_DONT = $FE;

 var
   tB   : Integer;
   LastChr:Char;
   TmpChr:Char;
   I : Integer;
   TmpStr:string;
   TmpReply : String;
begin
   Move(CS, SubSession, Sizeof(SubSession));
   tB:=Ord(C);
   IAC:=False;
   HandleIAC:='';
   Case IACState of
     0 : Begin
           If tB=255 then
             begin
               IACState:=1;
               HandleIAC:='';
               IAC:=True;
            end else begin
               IACState:=0;
               HandleIAC:=C;
               IAC:=False;
             end;
         End;
     1 : Begin
          IACState:=0;
          Case tB of
       IAC_SE  : IACState :=0;               {End of Subnegotiation parameters}
       IAC_NOP : asm nop end;                {NOTHING}
       IAC_DM  : HandleIAC:='(DataMark)';        {The Data stream portion of a Sync}
       IAC_BRK : HandleIAC:='(Break)';                 {NVT character BRK}
       IAC_IP  : HandleIAC:='(Interrupt Process)';     {The function IP}
       IAC_AO  : HandleIAC:='(Abort Output)';          {The function AO}
       IAC_AYT : Begin
                   HandleIAC:='(Are You There)';         {The function AYT}
                   tcp_sendtext(SubSession, '[Yes]');
                 End;
       IAC_EC  : HandleIAC:='(Erase Character)';       {The function EC}
       IAC_EL  : HandleIAC:='(Erase Line)';            {The function EL}
       IAC_GA  : HandleIAC:='(Go ahead)';              {The GA signal}
       IAC_SB  : Begin
                   IACState := 2;
                   SE:='';
                 End;
       IAC_WILL: IACState := 3;
       IAC_WONT: IACState := 4;
       IAC_DO  : IACState := 5;
       IAC_DONT: IACState := 6;
       IAC_IAC : HandleIAC:=C;
           Else
               begin
                IACState:=0;
                HandleIAC:=#$FF+C;
               end;
          End;
         End;
     2 : Begin
          ShowStatusBar('*Receiving SUBNeg stuff*');
          If tB=$FF then
              begin
                IACState:=7;
              end;
          SE:=SE+C;
          If Length(SE)>251 then
           begin
            IACState:=0;
            HandleIAC:='[ERR:'+SE+']';
           end;
          IAC:=True;
         End;
    3  : begin {WILL}
           IACState:=0;  Inc(NumIACReqs);
           If C in IACWILL_Handlers then
             Begin {Will Do}
                tcp_sendtext(SubSession, IACC_DO  +C);
                If C=#$01 then AvtEcho:=False;
             End ELSE Begin  {Will Don't #$05 }
                tcp_sendtext(SubSession, IACC_DONT  +C);
             End;
          IAC:=True;
         End;
    4  : begin {WONT}
          IACState:=0;   Inc(NumIACReqs);
          V:=#$01;
          If Pos(C,V)>0 then
               begin
                  tcp_sendtext(SubSession, IACC_DONT  +C);  {then Dont}
               end;
          If C=#$01 then AvtEcho := True;
           asm nop end;    {nothing here yet}
          IAC:=True;
         end;
    5  : begin {DO}
          IACState:=0;  Inc(NumIACReqs);
          If C in IACDO_Handlers then
             Begin
                  tcp_sendtext(SubSession, IACC_WILL  +C);
             End ELSE Begin
                  tcp_sendtext(SubSession, IACC_WONT  +C);
             End;
          IAC:=True;
         End;
    6  : begin {DONT}
          IACState:=0;   Inc(NumIACReqs);
          asm nop end;    { Nothing here yet either }
          IAC:=True;
         end;
    7  : Begin
          IACState:=0;
          TmpReply := '';
          SE:=SE+C;
          ShowStatusBar(SE);
          if Copy(SE, 1, 2)=#$24+#$00 then Writeln('[Received ENVIRON IS]');
{          if Copy(SE, 1, 2)=#$24+#$01 then Do_IAC_ENVIRON(Copy(SE, 2, Length(SE)));}
          if Copy(SE, 1, 2)=#$24+#$02 then Writeln('[Received ENVIRON INFO]');
          If SE=#$20+#$01+#$FF+#$F0 then
            begin
             ShowStatusBar('*Sending Terminal Speed*');
             tcp_sendtext(SubSession, IACC_SB + #$20+#$00+TerminalSpeed + IACC_SE);
             Result := tcp_Status(SubSession, 0);
               If Result=0 then ShowStatusBar('*TERMSPEEDSENT*')
                           else ShowStatusBar('*TERMSPEEDNOTSENT*');
            end;
          If SE=#$18+#$01+#$FF+#$F0 then
            begin
             ShowStatusbar('*Sending Terminal Type*');
             tcp_sendtext(SubSession, IACC_SB + #$18+#$00+TerminalType + IACC_SE);
             Result:=tcp_Status(SubSession,0);
                    If Result=0 then ShowStatusBar('*TERMTYPESENT*')
                                else ShowStatusBar('*TERMTYPENOTSENT*');
            end;
          IAC:=True;
         End;
    else
       IACState:=0;
   end;

   If IAC then HandleIAC:='';
   If IACState=0 then IAC:=False;
end;

var
  FAP : FieldType;
  A : String[50];

BEGIN
  { Do Will's }
  {  #$18 = TermType,  #$20 = TermSpeed,  #$24 = ENVIRON }
  IACDO_Handlers   := [ #$18, #$20  {, #$24} ];

  { Will Do's }
  IACWILL_Handlers := [ #$00, #$03, #$01   ];

  FAP.Field := 'Term';   FAP.Value:='vt102';
  LoadINISection(INIFileName, 'tn102', 1, @FAP);
  If FAP.Value<>'' then TerminalType := UCase(FAP.Value);
  If FAP.Value = '' then Exclude( IACDO_Handlers, #$18 );

  FAP.Field := 'InSpeed';   FAP.Value:='9600';
  LoadINISection(INIFileName, 'tn102', 1, @FAP);
  If FAP.Value<>'' then A:=FAP.Value  else FAP.Value:='2400';
  If FAP.Value=''  then Exclude( IACDO_Handlers, #$20 );
  FAP.Field := 'OutSpeed';   FAP.Value:='9600';
  LoadINISection(INIFileName, 'tn102', 1, @FAP);
  If FAP.Value<>'' then A:=A+','+FAP.Value;
  If FAP.Value=''  then Exclude( IACDO_Handlers, #$20 );
  TerminalSpeed := A;
  TrumpetBusy := False;
END.
